package pascal;

import pascal.parser.*;
import pascal.lexer.*;
import pascal.node.*;
import pascal.table.*;
import pascal.semantic.*;
import pascal.p4code.*;
import pascal.iterator.*;

import java.io.*;

public class Main{
  public static void main(String args[]){
    try{
      PushbackReader pr = new PushbackReader(
                          new BufferedReader(
                          new FileReader(args[0])),1024);
 
      Lexer l = new Lexer(pr);

      System.out.println("Parsing...");
      Parser p = new Parser(l);

      Start tree = p.parse();

      System.out.println("Checking... ");
      tree.apply(new SemanticAnalyzer());

      System.out.println("Generating P4-Code");
      CodeGenerator gen = new CodeGenerator();
      tree.apply(gen);

      pr.close();

    } catch (ArrayIndexOutOfBoundsException e) {
       e.printStackTrace();
    } catch (FileNotFoundException e) {
       e.printStackTrace();
    } catch (IOException e) {
       e.printStackTrace();
    } catch (Exception e) {
       System.out.println(e.getMessage());
    } 
  }
}