/* This file was generated by SableCC (http://www.sablecc.org/). */

package pascal.lexer;

import java.io.*;
import java.util.*;
import pascal.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TLpar(line, pos); }
    Token new1(int line, int pos) { return new TRpar(line, pos); }
    Token new2(int line, int pos) { return new TMult(line, pos); }
    Token new3(int line, int pos) { return new TPlus(line, pos); }
    Token new4(int line, int pos) { return new TComma(line, pos); }
    Token new5(int line, int pos) { return new TMinus(line, pos); }
    Token new6(int line, int pos) { return new TDot(line, pos); }
    Token new7(int line, int pos) { return new TDotdot(line, pos); }
    Token new8(int line, int pos) { return new TSlash(line, pos); }
    Token new9(int line, int pos) { return new TColon(line, pos); }
    Token new10(int line, int pos) { return new TColeq(line, pos); }
    Token new11(int line, int pos) { return new TSemi(line, pos); }
    Token new12(int line, int pos) { return new TLt(line, pos); }
    Token new13(int line, int pos) { return new TLe(line, pos); }
    Token new14(int line, int pos) { return new TNoteq(line, pos); }
    Token new15(int line, int pos) { return new TEq(line, pos); }
    Token new16(int line, int pos) { return new TGt(line, pos); }
    Token new17(int line, int pos) { return new TGe(line, pos); }
    Token new18(int line, int pos) { return new TLbra(line, pos); }
    Token new19(int line, int pos) { return new TRbra(line, pos); }
    Token new20(int line, int pos) { return new TFArctan(line, pos); }
    Token new21(int line, int pos) { return new TFAbs(line, pos); }
    Token new22(int line, int pos) { return new TAnd(line, pos); }
    Token new23(int line, int pos) { return new TArray(line, pos); }
    Token new24(int line, int pos) { return new TBiginn(line, pos); }
    Token new25(int line, int pos) { return new TTypeBool(line, pos); }
    Token new26(int line, int pos) { return new TCase(line, pos); }
    Token new27(int line, int pos) { return new TTypeChar(line, pos); }
    Token new28(int line, int pos) { return new TFChr(line, pos); }
    Token new29(int line, int pos) { return new TConst(line, pos); }
    Token new30(int line, int pos) { return new TCos(line, pos); }
    Token new31(int line, int pos) { return new TDiv(line, pos); }
    Token new32(int line, int pos) { return new TDo(line, pos); }
    Token new33(int line, int pos) { return new TDownto(line, pos); }
    Token new34(int line, int pos) { return new TElse(line, pos); }
    Token new35(int line, int pos) { return new TEnd(line, pos); }
    Token new36(int line, int pos) { return new TFEof(line, pos); }
    Token new37(int line, int pos) { return new TFEoln(line, pos); }
    Token new38(int line, int pos) { return new TEven(line, pos); }
    Token new39(int line, int pos) { return new TFExp(line, pos); }
    Token new40(int line, int pos) { return new TBFalse(line, pos); }
    Token new41(int line, int pos) { return new TFor(line, pos); }
    Token new42(int line, int pos) { return new TFunction(line, pos); }
    Token new43(int line, int pos) { return new TIf(line, pos); }
    Token new44(int line, int pos) { return new TInput(line, pos); }
    Token new45(int line, int pos) { return new TTypeInteger(line, pos); }
    Token new46(int line, int pos) { return new TFLn(line, pos); }
    Token new47(int line, int pos) { return new TMod(line, pos); }
    Token new48(int line, int pos) { return new TNot(line, pos); }
    Token new49(int line, int pos) { return new TOdd(line, pos); }
    Token new50(int line, int pos) { return new TOf(line, pos); }
    Token new51(int line, int pos) { return new TOr(line, pos); }
    Token new52(int line, int pos) { return new TFOrd(line, pos); }
    Token new53(int line, int pos) { return new TOutput(line, pos); }
    Token new54(int line, int pos) { return new TFPred(line, pos); }
    Token new55(int line, int pos) { return new TProcedure(line, pos); }
    Token new56(int line, int pos) { return new TProgramm(line, pos); }
    Token new57(int line, int pos) { return new TRead(line, pos); }
    Token new58(int line, int pos) { return new TReadln(line, pos); }
    Token new59(int line, int pos) { return new TTypeReal(line, pos); }
    Token new60(int line, int pos) { return new TRecord(line, pos); }
    Token new61(int line, int pos) { return new TRepeat(line, pos); }
    Token new62(int line, int pos) { return new TFRound(line, pos); }
    Token new63(int line, int pos) { return new TSin(line, pos); }
    Token new64(int line, int pos) { return new TSqr(line, pos); }
    Token new65(int line, int pos) { return new TFSqrt(line, pos); }
    Token new66(int line, int pos) { return new TFSucc(line, pos); }
    Token new67(int line, int pos) { return new TThen(line, pos); }
    Token new68(int line, int pos) { return new TTo(line, pos); }
    Token new69(int line, int pos) { return new TBTrue(line, pos); }
    Token new70(int line, int pos) { return new TFTrunc(line, pos); }
    Token new71(int line, int pos) { return new TTypee(line, pos); }
    Token new72(int line, int pos) { return new TUntil(line, pos); }
    Token new73(int line, int pos) { return new TVar(line, pos); }
    Token new74(int line, int pos) { return new TWhile(line, pos); }
    Token new75(int line, int pos) { return new TWrite(line, pos); }
    Token new76(int line, int pos) { return new TWriteln(line, pos); }
    Token new77(String text, int line, int pos) { return new TReal(text, line, pos); }
    Token new78(String text, int line, int pos) { return new TInteger(text, line, pos); }
    Token new79(String text, int line, int pos) { return new TIdentt(text, line, pos); }
    Token new80(String text, int line, int pos) { return new TChar(text, line, pos); }
    Token new81(String text, int line, int pos) { return new TBlank(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {39, 39, 5}, {40, 40, 6}, {41, 41, 7}, {42, 42, 8}, {43, 43, 9}, {44, 44, 10}, {45, 45, 11}, {46, 46, 12}, {47, 47, 13}, {48, 57, 14}, {58, 58, 15}, {59, 59, 16}, {60, 60, 17}, {61, 61, 18}, {62, 62, 19}, {65, 90, 20}, {91, 91, 21}, {93, 93, 22}, {97, 97, 23}, {98, 98, 24}, {99, 99, 25}, {100, 100, 26}, {101, 101, 27}, {102, 102, 28}, {103, 104, 20}, {105, 105, 29}, {106, 107, 20}, {108, 108, 30}, {109, 109, 31}, {110, 110, 32}, {111, 111, 33}, {112, 112, 34}, {113, 113, 20}, {114, 114, 35}, {115, 115, 36}, {116, 116, 37}, {117, 117, 38}, {118, 118, 39}, {119, 119, 40}, {120, 122, 20}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{0, 9, 41}, {11, 12, 41}, {14, 38, 41}, {39, 39, 42}, {40, 65535, 41}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{46, 46, 43}, },
            {},
            {{46, 46, 44}, {48, 57, 45}, {69, 69, 46}, },
            {{61, 61, 47}, },
            {},
            {{61, 61, 48}, {62, 62, 49}, },
            {},
            {{61, 61, 50}, },
            {{48, 57, 51}, {65, 90, 51}, {97, 122, 51}, },
            {},
            {},
            {{48, 90, -22}, {97, 97, 51}, {98, 98, 52}, {99, 109, 51}, {110, 110, 53}, {111, 113, 51}, {114, 114, 54}, {115, 122, 51}, },
            {{48, 90, -22}, {97, 100, 51}, {101, 101, 55}, {102, 110, 51}, {111, 111, 56}, {112, 122, 51}, },
            {{48, 90, -22}, {97, 97, 57}, {98, 103, 51}, {104, 104, 58}, {105, 110, 51}, {111, 111, 59}, {112, 122, 51}, },
            {{48, 90, -22}, {97, 104, 51}, {105, 105, 60}, {106, 110, 51}, {111, 111, 61}, {112, 122, 51}, },
            {{48, 90, -22}, {97, 107, 51}, {108, 108, 62}, {109, 109, 51}, {110, 110, 63}, {111, 111, 64}, {112, 117, 51}, {118, 118, 65}, {119, 119, 51}, {120, 120, 66}, {121, 122, 51}, },
            {{48, 90, -22}, {97, 97, 67}, {98, 110, 51}, {111, 111, 68}, {112, 116, 51}, {117, 117, 69}, {118, 122, 51}, },
            {{48, 90, -22}, {97, 101, 51}, {102, 102, 70}, {103, 109, 51}, {110, 110, 71}, {111, 122, 51}, },
            {{48, 90, -22}, {97, 109, 51}, {110, 110, 72}, {111, 122, 51}, },
            {{48, 90, -22}, {97, 110, 51}, {111, 111, 73}, {112, 122, 51}, },
            {{48, 110, -33}, {111, 111, 74}, {112, 122, 51}, },
            {{48, 90, -22}, {97, 99, 51}, {100, 100, 75}, {101, 101, 51}, {102, 102, 76}, {103, 113, 51}, {114, 114, 77}, {115, 116, 51}, {117, 117, 78}, {118, 122, 51}, },
            {{48, 90, -22}, {97, 113, 51}, {114, 114, 79}, {115, 122, 51}, },
            {{48, 100, -26}, {101, 101, 80}, {102, 110, 51}, {111, 111, 81}, {112, 122, 51}, },
            {{48, 104, -28}, {105, 105, 82}, {106, 112, 51}, {113, 113, 83}, {114, 116, 51}, {117, 117, 84}, {118, 122, 51}, },
            {{48, 90, -22}, {97, 103, 51}, {104, 104, 85}, {105, 110, 51}, {111, 111, 86}, {112, 113, 51}, {114, 114, 87}, {115, 120, 51}, {121, 121, 88}, {122, 122, 51}, },
            {{48, 109, -32}, {110, 110, 89}, {111, 122, 51}, },
            {{48, 90, -22}, {97, 97, 90}, {98, 122, 51}, },
            {{48, 103, -39}, {104, 104, 91}, {105, 113, 51}, {114, 114, 92}, {115, 122, 51}, },
            {{0, 65535, -7}, },
            {{0, 65535, -7}, },
            {},
            {{48, 57, 93}, },
            {{46, 46, 94}, {48, 57, 45}, },
            {{43, 43, 95}, {45, 45, 96}, {48, 57, 97}, },
            {},
            {},
            {},
            {},
            {{48, 122, -22}, },
            {{48, 90, -22}, {97, 114, 51}, {115, 115, 98}, {116, 122, 51}, },
            {{48, 99, -35}, {100, 100, 99}, {101, 122, 51}, },
            {{48, 90, -22}, {97, 98, 51}, {99, 99, 100}, {100, 113, 51}, {114, 114, 101}, {115, 122, 51}, },
            {{48, 90, -22}, {97, 102, 51}, {103, 103, 102}, {104, 122, 51}, },
            {{48, 110, -33}, {111, 111, 103}, {112, 122, 51}, },
            {{48, 114, -54}, {115, 115, 104}, {116, 122, 51}, },
            {{48, 90, -22}, {97, 97, 105}, {98, 113, 51}, {114, 114, 106}, {115, 122, 51}, },
            {{48, 109, -32}, {110, 110, 107}, {111, 114, 51}, {115, 115, 108}, {116, 122, 51}, },
            {{48, 90, -22}, {97, 117, 51}, {118, 118, 109}, {119, 122, 51}, },
            {{48, 90, -22}, {97, 118, 51}, {119, 119, 110}, {120, 122, 51}, },
            {{48, 114, -54}, {115, 115, 111}, {116, 122, 51}, },
            {{48, 99, -35}, {100, 100, 112}, {101, 122, 51}, },
            {{48, 101, -31}, {102, 102, 113}, {103, 107, 51}, {108, 108, 114}, {109, 122, 51}, },
            {{48, 100, -26}, {101, 101, 115}, {102, 122, 51}, },
            {{48, 90, -22}, {97, 111, 51}, {112, 112, 116}, {113, 122, 51}, },
            {{48, 107, -29}, {108, 108, 117}, {109, 122, 51}, },
            {{48, 113, -36}, {114, 114, 118}, {115, 122, 51}, },
            {{48, 109, -32}, {110, 110, 119}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 111, -68}, {112, 112, 120}, {113, 115, 51}, {116, 116, 121}, {117, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 99, -35}, {100, 100, 122}, {101, 122, 51}, },
            {{48, 90, -22}, {97, 115, 51}, {116, 116, 123}, {117, 122, 51}, },
            {{48, 99, -35}, {100, 100, 124}, {101, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 99, -35}, {100, 100, 125}, {101, 122, 51}, },
            {{48, 115, -76}, {116, 116, 126}, {117, 122, 51}, },
            {{48, 100, -26}, {101, 101, 127}, {102, 110, 51}, {111, 111, 128}, {112, 122, 51}, },
            {{48, 90, -22}, {97, 97, 129}, {98, 98, 51}, {99, 99, 130}, {100, 111, 51}, {112, 112, 131}, {113, 122, 51}, },
            {{48, 90, -22}, {97, 116, 51}, {117, 117, 132}, {118, 122, 51}, },
            {{48, 109, -32}, {110, 110, 133}, {111, 122, 51}, },
            {{48, 113, -36}, {114, 114, 134}, {115, 122, 51}, },
            {{48, 98, -56}, {99, 99, 135}, {100, 122, 51}, },
            {{48, 100, -26}, {101, 101, 136}, {102, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 116, -83}, {117, 117, 137}, {118, 122, 51}, },
            {{48, 111, -68}, {112, 112, 138}, {113, 122, 51}, },
            {{48, 115, -76}, {116, 116, 139}, {117, 122, 51}, },
            {{48, 113, -36}, {114, 114, 140}, {115, 122, 51}, },
            {{48, 104, -28}, {105, 105, 141}, {106, 122, 51}, },
            {{48, 104, -28}, {105, 105, 142}, {106, 122, 51}, },
            {{48, 57, 143}, {69, 69, 144}, },
            {{48, 57, 143}, },
            {{48, 57, 97}, },
            {{48, 57, 97}, },
            {{48, 57, 97}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 115, -76}, {116, 116, 145}, {117, 122, 51}, },
            {{48, 90, -22}, {97, 97, 146}, {98, 122, 51}, },
            {{48, 104, -28}, {105, 105, 147}, {106, 122, 51}, },
            {{48, 107, -29}, {108, 108, 148}, {109, 122, 51}, },
            {{48, 100, -26}, {101, 101, 149}, {102, 122, 51}, },
            {{48, 113, -36}, {114, 114, 150}, {115, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 114, -54}, {115, 115, 151}, {116, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 109, -32}, {110, 110, 152}, {111, 122, 51}, },
            {{48, 100, -26}, {101, 101, 153}, {102, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 109, -32}, {110, 110, 154}, {111, 122, 51}, },
            {{48, 109, -32}, {110, 110, 155}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 114, -54}, {115, 115, 156}, {116, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 98, -56}, {99, 99, 157}, {100, 122, 51}, },
            {{48, 116, -83}, {117, 117, 158}, {118, 122, 51}, },
            {{48, 100, -26}, {101, 101, 159}, {102, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 111, -68}, {112, 112, 160}, {113, 122, 51}, },
            {{48, 99, -35}, {100, 100, 161}, {101, 122, 51}, },
            {{48, 98, -56}, {99, 99, 162}, {100, 102, 51}, {103, 103, 163}, {104, 122, 51}, },
            {{48, 99, -35}, {100, 100, 164}, {101, 107, 51}, {108, 108, 165}, {109, 122, 51}, },
            {{48, 110, -33}, {111, 111, 166}, {112, 122, 51}, },
            {{48, 100, -26}, {101, 101, 167}, {102, 122, 51}, },
            {{48, 109, -32}, {110, 110, 168}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 115, -76}, {116, 116, 169}, {117, 122, 51}, },
            {{48, 98, -56}, {99, 99, 170}, {100, 122, 51}, },
            {{48, 109, -32}, {110, 110, 171}, {111, 122, 51}, },
            {{48, 100, -26}, {101, 101, 172}, {102, 109, 51}, {110, 110, 173}, {111, 122, 51}, },
            {{48, 100, -26}, {101, 101, 174}, {102, 122, 51}, },
            {{48, 104, -28}, {105, 105, 175}, {106, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 107, -29}, {108, 108, 176}, {109, 122, 51}, },
            {{48, 115, -76}, {116, 116, 177}, {117, 122, 51}, },
            {{48, 57, 143}, },
            {{43, 43, 178}, {45, 45, 179}, {48, 57, 180}, },
            {{48, 90, -22}, {97, 97, 181}, {98, 122, 51}, },
            {{48, 90, -22}, {97, 120, 51}, {121, 121, 182}, {122, 122, 51}, },
            {{48, 109, -32}, {110, 110, 183}, {111, 122, 51}, },
            {{48, 100, -26}, {101, 101, 184}, {102, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 115, -76}, {116, 116, 185}, {117, 122, 51}, },
            {{48, 115, -76}, {116, 116, 186}, {117, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 100, -26}, {101, 101, 187}, {102, 122, 51}, },
            {{48, 115, -76}, {116, 116, 188}, {117, 122, 51}, },
            {{48, 115, -76}, {116, 116, 189}, {117, 122, 51}, },
            {{48, 102, -57}, {103, 103, 190}, {104, 122, 51}, },
            {{48, 116, -83}, {117, 117, 191}, {118, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 100, -26}, {101, 101, 192}, {102, 122, 51}, },
            {{48, 113, -36}, {114, 114, 193}, {115, 122, 51}, },
            {{48, 107, -29}, {108, 108, 194}, {109, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 113, -36}, {114, 114, 195}, {115, 122, 51}, },
            {{48, 90, -22}, {97, 97, 196}, {98, 122, 51}, },
            {{48, 99, -35}, {100, 100, 197}, {101, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 98, -56}, {99, 99, 198}, {100, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 107, -29}, {108, 108, 199}, {109, 122, 51}, },
            {{48, 100, -26}, {101, 101, 200}, {102, 122, 51}, },
            {{48, 100, -26}, {101, 101, 201}, {102, 122, 51}, },
            {{48, 57, 180}, },
            {{48, 57, 180}, },
            {{48, 57, 180}, },
            {{48, 109, -32}, {110, 110, 202}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 90, -22}, {97, 97, 203}, {98, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 110, -33}, {111, 111, 204}, {112, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 104, -28}, {105, 105, 205}, {106, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 100, -26}, {101, 101, 206}, {102, 122, 51}, },
            {{48, 115, -76}, {116, 116, 207}, {117, 122, 51}, },
            {{48, 99, -35}, {100, 100, 208}, {101, 122, 51}, },
            {{48, 90, -22}, {97, 97, 209}, {98, 122, 51}, },
            {{48, 109, -32}, {110, 110, 210}, {111, 122, 51}, },
            {{48, 99, -35}, {100, 100, 211}, {101, 122, 51}, },
            {{48, 115, -76}, {116, 116, 212}, {117, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 107, -29}, {108, 108, 213}, {109, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 109, -32}, {110, 110, 214}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 110, -33}, {111, 111, 215}, {112, 122, 51}, },
            {{48, 113, -36}, {114, 114, 216}, {115, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 116, -83}, {117, 117, 217}, {118, 122, 51}, },
            {{48, 90, -22}, {97, 108, 51}, {109, 109, 218}, {110, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 109, -32}, {110, 110, 219}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 109, -32}, {110, 110, 220}, {111, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 113, -36}, {114, 114, 221}, {115, 122, 51}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 122, -22}, },
            {{48, 100, -26}, {101, 101, 222}, {102, 122, 51}, },
            {{48, 122, -22}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {77, 81, 81, 81, 81, -1, 0, 1, 2, 3, 4, 5, 6, 8, 78, 9, 11, 12, 15, 16, 79, 18, 19, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, -1, 80, 7, -1, 78, -1, 10, 13, 14, 17, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 32, 79, 79, 79, 79, 79, 79, 79, 79, 43, 79, 46, 79, 79, 79, 50, 51, 79, 79, 79, 79, 79, 79, 79, 79, 68, 79, 79, 79, 79, 79, 79, 77, -1, -1, -1, 78, 21, 22, 79, 79, 79, 79, 79, 79, 28, 79, 30, 31, 79, 79, 35, 36, 79, 79, 39, 79, 41, 79, 79, 79, 47, 48, 49, 52, 79, 79, 79, 79, 79, 79, 79, 63, 64, 79, 79, 79, 79, 79, 73, 79, 79, 77, -1, 79, 79, 79, 79, 26, 27, 79, 79, 34, 37, 38, 79, 79, 79, 79, 79, 54, 79, 79, 57, 59, 79, 79, 79, 65, 66, 67, 69, 79, 71, 79, 79, 79, -1, -1, 77, 79, 23, 24, 79, 29, 79, 40, 79, 44, 79, 79, 79, 79, 79, 79, 79, 62, 70, 72, 74, 75, 20, 79, 33, 79, 79, 53, 79, 79, 58, 60, 61, 79, 25, 79, 45, 79, 56, 76, 42, 79, 55, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
