package pascal.p4code;

import java.io.*;
import java.util.*;

public class Code{
  private int stack_val = 0;
  private int stack_max = 0;

  private static final int null_val = 0;

  private PrintWriter pw;

  private LinkedList char_string = new LinkedList(); 

  private static String mntbl[] = {
     "ab", "ad", "and", "chk", "chr", "csp", "cup", "dec", "dif", "dv", "ent",
     "eof", "equ", "fjp",  "flo",  "flt",  "geq",  "grt",  "inc",  "ind", "inn",
     "int", "ior", "ixa",  "lao",  "lca",  "lci",  "lda",  "ldc",  "ldo", "leq",
     "les", "lod", "mod",  "mov",  "mp",   "mst",  "neq",  "ng",   "not", "odd",
     "ord", "ret", "sb",   "sgs",  "sq",   "sro",  "sto",  "stp",  "str", "trc",
     "ujp", "ujp", "uni",  "xjp",  "lab",  "q",    " ",    "nop"
  };

  private static int cdx[] = {
     0, -1, -1,  0,  0,  0,  0,  0, -1, -1,  0,
     0, -1, -1,  0,  0, -1, -1,  0,  0, -1,
    -1, -1, -1,  1,  1,  1,  1,  1,  1, -1,
    -1,  1, -1, -2, -1,  0,  0,  0,  0,  0,
     0,  0, -1,  0,  0, -1, -2,  0, -1,  0,
     0,  0, -1, -1,  0, 0, 0, 0
  }; 

  private static String ftbl[] = {
    "sin", "cos", "atn", "odd", "even", "sqt", "round", "trunc", "exp", "log",
    "chr", "ord", "eln", "rd",  "rln",  "wr",  "wln"
  };

  private static String codetypr[]={
    "integer", "real", "character", "boolean", "addr",
    "string", "etc"
  };

  Code(PrintWriter pw){
    this.pw = pw;
  }

  public static Codeptr nullcode(){
    return  gen(Opecode.o_nop);
  }

  public static Codeptr gen(int f, int l, double a1, double a2){
    Codestr sp = new Codestr(new Instruction(f, l, a1, a2));
    return  new Codeptr(sp, sp);
  }

  public static Codeptr gen(int f){
    Codestr sp = new Codestr(new Instruction(f));
    return  new Codeptr(sp, sp);
  }

  public static Codeptr concat(Codeptr c1, Codeptr c2){
    if(c2.getHead() != null && c1.getHead() != null && c1.getTail() != null){
      c1.getTail().setNext(c2.getHead());
      c2.getHead().setPrev(c1.getTail());
      c1.setTail(c2.getTail());
    } else {
       System.out.println("error");
       System.exit(1);
    }
    return c1;
  }

  public static Codeptr concat(Codeptr c1, Codeptr c2, Codeptr c3){
     return concat(c1, concat(c2, c3));
  }

  public static Codeptr concat(Codeptr c1, Codeptr c2, Codeptr c3, Codeptr c4){
     return concat(c1, concat(c2, c3, c4));
  }

  public static Codeptr concat
       (Codeptr c1, Codeptr c2, Codeptr c3, Codeptr c4, Codeptr c5){
    return concat(c1, concat(c2, c3, c4, c5));
  }

  public static Codeptr concat
       (Codeptr c1, Codeptr c2, Codeptr c3, Codeptr c4, Codeptr c5, Codeptr c6){
    return concat(c1, concat(c2, c3, c4, c5, c6));
  }

  public static Codeptr concat
       (Codeptr c1, Codeptr c2, Codeptr c3,Codeptr c4,
           Codeptr c5, Codeptr c6, Codeptr c7){
    return concat(c1, concat(c2, c3, c4, c5, c6, c7));
  }

  public static Codeptr concat
      (Codeptr c1, Codeptr c2, Codeptr c3, Codeptr c4, 
           Codeptr c5, Codeptr c6, Codeptr c7, Codeptr c8){
    return concat(c1, concat(c2, c3, c4, c5, c6, c7, c8));
  }


  public static void printcode(Codeptr cp){
    int f, l;
    double a1, a2;

    Codestr wp = cp.getHead();

    System.out.println();
    while(wp != null){
      f = wp.getInst().getF();
      l = wp.getInst().getL();
      a1 = wp.getInst().getA1();
      a2 = wp.getInst().getA2();
      System.out.println(mntbl[f] + " , " + l + " , " + a1 + " , " + a2);
      wp=wp.getNext();
    }
    System.out.println();
  }

  private void AddVal(int val){
    stack_val += val;
    if(stack_val > stack_max){
      stack_max = stack_val;
    }
  }

  public double setCharString(String s){
    char_string.add(s);
    return (double)(char_string.size() - 1);
  }

  private void printSpace(int space, int num){
    String str = new Integer(num).toString();
    int i = space - str.length();
    while(i > 0){
      pw.print(" ");
      i--;
    }
    pw.print(num);
  }

  private void printSpace(int space, StringBuffer sb){
    int i = space - sb.length();
    while(i > 0){
      pw.print(" ");
      i--;
    }
    pw.print(sb);
  }

  private void printSpace(int space, double  num){
    String str = new Double(num).toString();
    int point = str.indexOf(".");
    str = str.substring(0, point-1);
    int i = space - str.length();
    while(i > 0){
      pw.print(" ");
      i--;
    }
    pw.print(num);
  }

  public void linearize(Codeptr cp){
    Codestr wp;
    int l, f;
    double a1, a2;
    int  i = 3, j , k = 0;

    if(cp.getHead() == null){
      System.out.println("error");
      System.exit(1);
    }

    for(wp = cp.getHead();  wp != null; wp = wp.getNext(), i++){
      f = wp.getInst().getF();
      l = wp.getInst().getL();
      a1 = wp.getInst().getA1();
      a2 = wp.getInst().getA2();

      if( i % 10 == 0  && f != Opecode.o_lab && f != Opecode.o_q && i != k){
        pw.print("i");
        printSpace(5, i);
        pw.println();
        k=i;
      }

      switch(f){
        case Opecode.o_csp:
        case Opecode.o_ret:
          stack_val = 0;
          break;

        default:
          AddVal(cdx[f]);
          break;
      }

      switch(f){
        case Opecode.o_lab:
          if(l == 0){
            pw.print("l");
            printSpace(4, (int)a1);
            pw.println();
          } else {
            pw.print("l");
            printSpace(4, (int)a1);
            pw.print("=");
            printSpace(10, (int)a2);
            pw.println();

            wp = wp.getNext();
            f = wp.getInst().getF();
            l = wp.getInst().getL();
            a1 = wp.getInst().getA1();
            a2 = wp.getInst().getA2();
            pw.print("l");
            printSpace(4, (int)a1);
            pw.print("="); 
            printSpace(10,  stack_max + 5);
            pw.println();
            stack_max = 0; 
          }
          i--;
          break;

        case Opecode.o_ent:
          if(l == 1){
            pw.print(" ent   1   l");
            printSpace(4, (int)a1);
            pw.println();
          }else{
            pw.print(" ent   2   l");
            printSpace(4, (int)a1);
            pw.println();
          }
          break;

        case Opecode.o_ret :
          switch(l){
            case Codetype.c_integer:
              pw.println(" reti");
              break;
            case Codetype.c_real:
              pw.println(" retr");
              break;
            case Codetype.c_character:
              pw.println(" retc");
              break;
            case Codetype.c_boolean:
              pw.println(" retb");
              break;
            case Codetype.c_etc:
              pw.println(" retp");
              break;
          }
          break;

        case Opecode.o_cup:
          pw.print(" cup");
          printSpace(4,  l);  
          pw.print("   l");
          printSpace(4, (int)a1);
          pw.println();
          break;
      
        case Opecode.o_eof:
          pw.println(" eof");
          break;

        case Opecode.o_csp:
          {
            StringBuffer sb = new StringBuffer(ftbl[l]);
            if(l == Builtinfunc.read || l == Builtinfunc.write){
              switch((int)a1){
                case Codetype.c_integer:
                  sb.append("i");
                  break;
                case Codetype.c_real:
                  sb.append("r");
                  break;
                case Codetype.c_character:
                  sb.append("c");
                  break;
                case Codetype.c_boolean:
                  sb.append("b");
                  break;
                case Codetype.c_string:
                  sb.append("s");
                  break;
              }
            }
            pw.print(" csp ");
            printSpace(11, sb);
            pw.println();
          }
          break;

        case Opecode.o_lda:
          pw.print(" " + mntbl[f]);
          printSpace(4, (int)a1);
          printSpace(8, (int)a2);
          pw.println();
          break;

        case Opecode.o_lod:
        case Opecode.o_str:
          {
            StringBuffer sb = new StringBuffer(mntbl[f]);
            switch(l){
              case Codetype.c_integer:
                sb.append("i");
                break;
              case Codetype.c_real:
                sb.append("r");
                break; 
              case Codetype.c_character:
                sb.append("c");
                break;
              case Codetype.c_boolean:
                sb.append("b");
                break;
              case Codetype.c_addr:
                sb.append("a");
                break;
            }
            pw.print(" " + sb);
            printSpace(3, (int)a1);  
            pw.print("    ");
            printSpace(4,(int)a2);
            pw.println();
          }
          break; 

        case Opecode.o_lca:
          pw.println(" " + mntbl[f] + char_string.get(l).toString());        
          break;

        case Opecode.o_ldc:
          pw.print(" ");
          switch(l){
            case Codetype.c_integer:
              pw.print(mntbl[f] + "i");
              printSpace(11, (int)a1);
              pw.println(); 
              break; 
            case Codetype.c_real:
              pw.print(mntbl[f] + "r");
              printSpace(3,a1);
              pw.println();
              break; 
            case Codetype.c_character:
              pw.println(mntbl[f] + "c" + char_string.get((int)a1).toString());
              break;
            case Codetype.c_boolean:
              pw.println(mntbl[f] + "b          " +(int)a1);
              break;
          }
          break;

        case Opecode.o_ind:
          {
            StringBuffer sb = new StringBuffer(mntbl[f]);
            switch(l){
              case Codetype.c_integer:
                sb.append("i");
                break;
              case Codetype.c_real:
                sb.append("r");
                break;
              case Codetype.c_character:
                sb.append("c");
                break;  
              case Codetype.c_boolean:
                sb.append("b");
                break;
            }  
            pw.print(" " + sb);
            printSpace(11, (int)a1);
            pw.println();
          }
          break;

        case Opecode.o_ldo:
        case Opecode.o_dec:
        case Opecode.o_inc:
          {
            StringBuffer sb = new StringBuffer(mntbl[f]);
            switch(l){
              case Codetype.c_integer:
                sb.append("i");
                break;  
              case Codetype.c_real:
                sb.append("r");
                break; 
              case Codetype.c_character:
                sb.append("c");
                break;  
              case Codetype.c_boolean:
                sb.append("b");
                break;
              case Codetype.c_addr:
                sb.append("a");
                break;
            }
            pw.print(" " + sb);
            printSpace(11, (int)a1);
            pw.println();
          }
          break;

        case Opecode.o_sro:
          {
            StringBuffer sb = new StringBuffer(mntbl[f]);
            switch(l){
              case Codetype.c_integer:
                sb.append("i");
                break;  
              case Codetype.c_real:
                sb.append("r");
                break;
              case Codetype.c_character:
                sb.append("c");
                break;  
              case Codetype.c_boolean:
                sb.append("b");
                break;
            }
            pw.print(" " + sb);
            printSpace(11, (int)a1);
            pw.println();
          }
          break;

        case Opecode.o_sto:
        case Opecode.o_ng:
        case Opecode.o_sq:
        case Opecode.o_ab:
        case Opecode.o_ad:
        case Opecode.o_sb:
        case Opecode.o_mp:
        case Opecode.o_dv:
        case Opecode.o_equ:
        case Opecode.o_neq:
        case Opecode.o_grt:
        case Opecode.o_les:
        case Opecode.o_geq:
        case Opecode.o_leq:
        case Opecode.o_ord:
          pw.print(" ");
          switch(l){
            case Codetype.c_integer:
              pw.println(mntbl[f] + "i");
              break;  
            case Codetype.c_real:
              pw.println(mntbl[f] + "r");
              break;  
            case Codetype.c_character:
              pw.println(mntbl[f] + "c");
              break;  
            case Codetype.c_boolean:
              pw.println(mntbl[f] + "b");
              break;
          }
          break;

        case Opecode.o_chk:
          {
            StringBuffer sb = new StringBuffer(mntbl[f]);
            switch(l){
              case Codetype.c_integer:
                sb.append("i");
                break;
              case Codetype.c_real:
                sb.append("r");
                break; 
              case Codetype.c_character:
                sb.append("c");
                break; 
              case Codetype.c_boolean:
                sb.append("b");
                break;
            }
            pw.print(" " + sb);
            printSpace(3, (int)a1); 
            pw.print("    ");
            printSpace(4, (int)a2);
            pw.println();
          }
          break;

        case Opecode.o_fjp:
        case Opecode.o_ujp:
        case Opecode.o_xjp:
          pw.print(" " + mntbl[f] +"       l");
          printSpace(4,  l);
          pw.println();
          break;

        case Opecode.o_stp:
        case Opecode.o_not:
        case Opecode.o_flt:
        case Opecode.o_flo:
        case Opecode.o_ior:
        case Opecode.o_mod:
        case Opecode.o_and:
        case Opecode.o_ujc:
        case Opecode.o_chr:
          pw.println(" " + mntbl[f]);
          break;
  
        case Opecode.o_ixa:
        case Opecode.o_lao:
        case Opecode.o_mst:
        case Opecode.o_mov:
          pw.print(" " + mntbl[f]);
          printSpace(12, (int)a1);
          pw.println();
          break;

        case Opecode.o_odd:
        case Opecode.o_trc:
          pw.print(" " + mntbl[f]);
          break;

        case Opecode.o_q:
          pw.println("q");
          pw.println("i    0");
          i=1;
          break;

        case Opecode.o_nop:
          i--;
          break;

        default:
          pw.print(" " + mntbl[f]);
          printSpace(4, l);
          pw.print("  ");
          printSpace(4, (int)a1);
          pw.println();
          break;
      }
    }
    pw.println("q");
    pw.close();
  }
}
