/* This file was generated by SableCC (http://www.sablecc.org/). */

package pascal.parser;

import pascal.lexer.*;
import pascal.node.*;
import pascal.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(1), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(2), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(2), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(3), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(4), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(5), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(6), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(7), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(7), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(8), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(8), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(9), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(10), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(10), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(11), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(11), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(12), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(13), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(13), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(14), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(14), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(15), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(16), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(16), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(17), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(18), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(18), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(19), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(19), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(20), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(20), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(21), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(22), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(23), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(24), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(25), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(25), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(26), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(26), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(26), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(26), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(27), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(28), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(28), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(28), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(29), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(29), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(30), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(31), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(31), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(32), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(33), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(33), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(34), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(34), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(35), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(35), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(36), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(37), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(37), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(38), node, true); } break;
                    case 62: { Node node = new62(); push(goTo(38), node, true); } break;
                    case 63: { Node node = new63(); push(goTo(38), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(38), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(38), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(38), node, true); } break;
                    case 67: { Node node = new67(); push(goTo(38), node, true); } break;
                    case 68: { Node node = new68(); push(goTo(38), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(38), node, true); } break;
                    case 70: { Node node = new70(); push(goTo(39), node, true); } break;
                    case 71: { Node node = new71(); push(goTo(39), node, true); } break;
                    case 72: { Node node = new72(); push(goTo(40), node, true); } break;
                    case 73: { Node node = new73(); push(goTo(40), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(40), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(41), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(41), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(41), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(41), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(41), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(42), node, true); } break;
                    case 81: { Node node = new81(); push(goTo(42), node, true); } break;
                    case 82: { Node node = new82(); push(goTo(43), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(44), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(44), node, true); } break;
                    case 85: { Node node = new85(); push(goTo(44), node, true); } break;
                    case 86: { Node node = new86(); push(goTo(45), node, true); } break;
                    case 87: { Node node = new87(); push(goTo(45), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(46), node, true); } break;
                    case 89: { Node node = new89(); push(goTo(46), node, true); } break;
                    case 90: { Node node = new90(); push(goTo(46), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(46), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(46), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(46), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(47), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(48), node, true); } break;
                    case 96: { Node node = new96(); push(goTo(48), node, true); } break;
                    case 97: { Node node = new97(); push(goTo(49), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(49), node, true); } break;
                    case 99: { Node node = new99(); push(goTo(50), node, true); } break;
                    case 100: { Node node = new100(); push(goTo(50), node, true); } break;
                    case 101: { Node node = new101(); push(goTo(51), node, true); } break;
                    case 102: { Node node = new102(); push(goTo(52), node, true); } break;
                    case 103: { Node node = new103(); push(goTo(53), node, true); } break;
                    case 104: { Node node = new104(); push(goTo(54), node, true); } break;
                    case 105: { Node node = new105(); push(goTo(55), node, true); } break;
                    case 106: { Node node = new106(); push(goTo(55), node, true); } break;
                    case 107: { Node node = new107(); push(goTo(56), node, true); } break;
                    case 108: { Node node = new108(); push(goTo(56), node, true); } break;
                    case 109: { Node node = new109(); push(goTo(56), node, true); } break;
                    case 110: { Node node = new110(); push(goTo(56), node, true); } break;
                    case 111: { Node node = new111(); push(goTo(56), node, true); } break;
                    case 112: { Node node = new112(); push(goTo(56), node, true); } break;
                    case 113: { Node node = new113(); push(goTo(57), node, true); } break;
                    case 114: { Node node = new114(); push(goTo(57), node, true); } break;
                    case 115: { Node node = new115(); push(goTo(58), node, true); } break;
                    case 116: { Node node = new116(); push(goTo(58), node, true); } break;
                    case 117: { Node node = new117(); push(goTo(58), node, true); } break;
                    case 118: { Node node = new118(); push(goTo(58), node, true); } break;
                    case 119: { Node node = new119(); push(goTo(59), node, true); } break;
                    case 120: { Node node = new120(); push(goTo(59), node, true); } break;
                    case 121: { Node node = new121(); push(goTo(59), node, true); } break;
                    case 122: { Node node = new122(); push(goTo(60), node, true); } break;
                    case 123: { Node node = new123(); push(goTo(60), node, true); } break;
                    case 124: { Node node = new124(); push(goTo(60), node, true); } break;
                    case 125: { Node node = new125(); push(goTo(60), node, true); } break;
                    case 126: { Node node = new126(); push(goTo(60), node, true); } break;
                    case 127: { Node node = new127(); push(goTo(60), node, true); } break;
                    case 128: { Node node = new128(); push(goTo(61), node, true); } break;
                    case 129: { Node node = new129(); push(goTo(61), node, true); } break;
                    case 130: { Node node = new130(); push(goTo(62), node, true); } break;
                    case 131: { Node node = new131(); push(goTo(62), node, true); } break;
                    case 132: { Node node = new132(); push(goTo(63), node, true); } break;
                    case 133: { Node node = new133(); push(goTo(64), node, true); } break;
                    case 134: { Node node = new134(); push(goTo(64), node, true); } break;
                    case 135: { Node node = new135(); push(goTo(64), node, true); } break;
                    case 136: { Node node = new136(); push(goTo(64), node, true); } break;
                    case 137: { Node node = new137(); push(goTo(65), node, true); } break;
                    case 138: { Node node = new138(); push(goTo(66), node, true); } break;
                    case 139: { Node node = new139(); push(goTo(66), node, true); } break;
                    case 140: { Node node = new140(); push(goTo(67), node, true); } break;
                    case 141: { Node node = new141(); push(goTo(67), node, true); } break;
                    case 142: { Node node = new142(); push(goTo(67), node, true); } break;
                    case 143: { Node node = new143(); push(goTo(67), node, true); } break;
                    case 144: { Node node = new144(); push(goTo(67), node, true); } break;
                    case 145: { Node node = new145(); push(goTo(67), node, true); } break;
                    case 146: { Node node = new146(); push(goTo(67), node, true); } break;
                    case 147: { Node node = new147(); push(goTo(67), node, true); } break;
                    case 148: { Node node = new148(); push(goTo(67), node, true); } break;
                    case 149: { Node node = new149(); push(goTo(67), node, true); } break;
                    case 150: { Node node = new150(); push(goTo(67), node, true); } break;
                    case 151: { Node node = new151(); push(goTo(67), node, true); } break;
                    case 152: { Node node = new152(); push(goTo(67), node, true); } break;
                    case 153: { Node node = new153(); push(goTo(67), node, true); } break;
                    case 154: { Node node = new154(); push(goTo(67), node, true); } break;
                    case 155: { Node node = new155(); push(goTo(67), node, true); } break;
                    case 156: { Node node = new156(); push(goTo(68), node, true); } break;
                    case 157: { Node node = new157(); push(goTo(69), node, true); } break;
                    case 158: { Node node = new158(); push(goTo(69), node, true); } break;
                    case 159: { Node node = new159(); push(goTo(70), node, true); } break;
                    case 160: { Node node = new160(); push(goTo(70), node, true); } break;
                    case 161: { Node node = new161(); push(goTo(71), node, true); } break;
                    case 162: { Node node = new162(); push(goTo(71), node, true); } break;
                    case 163: { Node node = new163(); push(goTo(72), node, true); } break;
                    case 164: { Node node = new164(); push(goTo(72), node, true); } break;
                    case 165: { Node node = new165(); push(goTo(73), node, true); } break;
                    case 166: { Node node = new166(); push(goTo(73), node, true); } break;
                    case 167: { Node node = new167(); push(goTo(73), node, true); } break;
                    case 168: { Node node = new168(); push(goTo(73), node, true); } break;
                    case 169: { Node node = new169(); push(goTo(74), node, true); } break;
                    case 170: { Node node = new170(); push(goTo(74), node, true); } break;
                    case 171: { Node node = new171(); push(goTo(75), node, true); } break;
                    case 172: { Node node = new172(); push(goTo(76), node, true); } break;
                    case 173: { Node node = new173(); push(goTo(76), node, true); } break;
                    case 174: { Node node = new174(); push(goTo(77), node, true); } break;
                    case 175: { Node node = new175(); push(goTo(78), node, true); } break;
                    case 176: { Node node = new176(); push(goTo(79), node, true); } break;
                    case 177: { Node node = new177(); push(goTo(79), node, true); } break;
                    case 178: { Node node = new178(); push(goTo(79), node, true); } break;
                    case 179: { Node node = new179(); push(goTo(79), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProgram node1 = (PProgram) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        TDot node4 = (TDot) pop();
        PBlock node3 = (PBlock) pop();
        TSemi node2 = (TSemi) pop();
        PProgramHead node1 = (PProgramHead) pop();
        AProgram node = new AProgram(node1, node2, node3, node4);
        return node;
    }

    Node new1()
    {
        TRpar node5 = (TRpar) pop();
        PFileNameList node4 = (PFileNameList) pop();
        TLpar node3 = (TLpar) pop();
        PIdent node2 = (PIdent) pop();
        TProgramm node1 = (TProgramm) pop();
        AProgramHead node = new AProgramHead(node1, node2, node3, node4, node5);
        return node;
    }

    Node new2()
    {
        TOutput node3 = (TOutput) pop();
        TComma node2 = (TComma) pop();
        TInput node1 = (TInput) pop();
        AInputFileNameList node = new AInputFileNameList(node1, node2, node3);
        return node;
    }

    Node new3()
    {
        TOutput node1 = (TOutput) pop();
        AOutputFileNameList node = new AOutputFileNameList(node1);
        return node;
    }

    Node new4()
    {
        PStmtPart node2 = (PStmtPart) pop();
        PConstTypeVarProcFuncDeclPart node1 = (PConstTypeVarProcFuncDeclPart) pop();
        ABlock node = new ABlock(node1, node2);
        return node;
    }

    Node new5()
    {
        PProcFuncDeclPart node2 = (PProcFuncDeclPart) pop();
        PConstTypeVarDeclPart node1 = (PConstTypeVarDeclPart) pop();
        AConstTypeVarProcFuncDeclPart node = new AConstTypeVarProcFuncDeclPart(node1, node2);
        return node;
    }

    Node new6()
    {
        PVarDeclPart node2 = (PVarDeclPart) pop();
        PConstTypeDeclPart node1 = (PConstTypeDeclPart) pop();
        AConstTypeVarDeclPart node = new AConstTypeVarDeclPart(node1, node2);
        return node;
    }

    Node new7()
    {
        PTypeDeclPart node2 = (PTypeDeclPart) pop();
        PConstDeclPart node1 = (PConstDeclPart) pop();
        AConstTypeDeclPart node = new AConstTypeDeclPart(node1, node2);
        return node;
    }

    Node new8()
    {
        TSemi node3 = (TSemi) pop();
        PConstDeclList node2 = (PConstDeclList) pop();
        TConst node1 = (TConst) pop();
        AConstConstDeclPart node = new AConstConstDeclPart(node1, node2, node3);
        return node;
    }

    Node new9()
    {
        AEmptyConstDeclPart node = new AEmptyConstDeclPart();
        return node;
    }

    Node new10()
    {
        PConstDecl node3 = (PConstDecl) pop();
        TSemi node2 = (TSemi) pop();
        PConstDeclList node1 = (PConstDeclList) pop();
        AConstDeclListConstDeclList node = new AConstDeclListConstDeclList(node1, node2, node3);
        return node;
    }

    Node new11()
    {
        PConstDecl node1 = (PConstDecl) pop();
        AConstDeclConstDeclList node = new AConstDeclConstDeclList(node1);
        return node;
    }

    Node new12()
    {
        PConstant node3 = (PConstant) pop();
        TEq node2 = (TEq) pop();
        PIdent node1 = (PIdent) pop();
        AConstDecl node = new AConstDecl(node1, node2, node3);
        return node;
    }

    Node new13()
    {
        TSemi node3 = (TSemi) pop();
        PTypeDeclList node2 = (PTypeDeclList) pop();
        TTypee node1 = (TTypee) pop();
        ATypeTypeDeclPart node = new ATypeTypeDeclPart(node1, node2, node3);
        return node;
    }

    Node new14()
    {
        AEmptyTypeDeclPart node = new AEmptyTypeDeclPart();
        return node;
    }

    Node new15()
    {
        PTypeDecl node3 = (PTypeDecl) pop();
        TSemi node2 = (TSemi) pop();
        PTypeDeclList node1 = (PTypeDeclList) pop();
        ATypeDeclListTypeDeclList node = new ATypeDeclListTypeDeclList(node1, node2, node3);
        return node;
    }

    Node new16()
    {
        PTypeDecl node1 = (PTypeDecl) pop();
        ATypeDeclTypeDeclList node = new ATypeDeclTypeDeclList(node1);
        return node;
    }

    Node new17()
    {
        PType node3 = (PType) pop();
        TEq node2 = (TEq) pop();
        PIdent node1 = (PIdent) pop();
        ATypeDecl node = new ATypeDecl(node1, node2, node3);
        return node;
    }

    Node new18()
    {
        TSemi node3 = (TSemi) pop();
        PVarDeclList node2 = (PVarDeclList) pop();
        TVar node1 = (TVar) pop();
        AVarVarDeclPart node = new AVarVarDeclPart(node1, node2, node3);
        return node;
    }

    Node new19()
    {
        AEmptyVarDeclPart node = new AEmptyVarDeclPart();
        return node;
    }

    Node new20()
    {
        PVarDecl node3 = (PVarDecl) pop();
        TSemi node2 = (TSemi) pop();
        PVarDeclList node1 = (PVarDeclList) pop();
        AVarDeclListVarDeclList node = new AVarDeclListVarDeclList(node1, node2, node3);
        return node;
    }

    Node new21()
    {
        PVarDecl node1 = (PVarDecl) pop();
        AVarDeclVarDeclList node = new AVarDeclVarDeclList(node1);
        return node;
    }

    Node new22()
    {
        PType node3 = (PType) pop();
        TColon node2 = (TColon) pop();
        PIdentList node1 = (PIdentList) pop();
        AVarDecl node = new AVarDecl(node1, node2, node3);
        return node;
    }

    Node new23()
    {
        PIdent node3 = (PIdent) pop();
        TComma node2 = (TComma) pop();
        PIdentList node1 = (PIdentList) pop();
        AIdentListIdentList node = new AIdentListIdentList(node1, node2, node3);
        return node;
    }

    Node new24()
    {
        PIdent node1 = (PIdent) pop();
        AIdentIdentList node = new AIdentIdentList(node1);
        return node;
    }

    Node new25()
    {
        TIdentt node1 = (TIdentt) pop();
        AIdent node = new AIdent(node1);
        return node;
    }

    Node new26()
    {
        PProcFuncDeclList node1 = (PProcFuncDeclList) pop();
        AProcFuncDeclListProcFuncDeclPart node = new AProcFuncDeclListProcFuncDeclPart(node1);
        return node;
    }

    Node new27()
    {
        AEmptyProcFuncDeclPart node = new AEmptyProcFuncDeclPart();
        return node;
    }

    Node new28()
    {
        PProcFuncDecl node2 = (PProcFuncDecl) pop();
        PProcFuncDeclList node1 = (PProcFuncDeclList) pop();
        AProcFuncDeclListProcFuncDeclList node = new AProcFuncDeclListProcFuncDeclList(node1, node2);
        return node;
    }

    Node new29()
    {
        PProcFuncDecl node1 = (PProcFuncDecl) pop();
        AProcFuncDeclProcFuncDeclList node = new AProcFuncDeclProcFuncDeclList(node1);
        return node;
    }

    Node new30()
    {
        PProcDecl node1 = (PProcDecl) pop();
        AProcDeclProcFuncDecl node = new AProcDeclProcFuncDecl(node1);
        return node;
    }

    Node new31()
    {
        PFuncDecl node1 = (PFuncDecl) pop();
        AFuncDeclProcFuncDecl node = new AFuncDeclProcFuncDecl(node1);
        return node;
    }

    Node new32()
    {
        TSemi node4 = (TSemi) pop();
        PBlock node3 = (PBlock) pop();
        TSemi node2 = (TSemi) pop();
        PProcDeclHead node1 = (PProcDeclHead) pop();
        AProcDecl node = new AProcDecl(node1, node2, node3, node4);
        return node;
    }

    Node new33()
    {
        PFormalParamList node3 = (PFormalParamList) pop();
        PIdent node2 = (PIdent) pop();
        TProcedure node1 = (TProcedure) pop();
        AProcDeclHead node = new AProcDeclHead(node1, node2, node3);
        return node;
    }

    Node new34()
    {
        TSemi node4 = (TSemi) pop();
        PBlock node3 = (PBlock) pop();
        TSemi node2 = (TSemi) pop();
        PFuncDeclHead node1 = (PFuncDeclHead) pop();
        AFuncDecl node = new AFuncDecl(node1, node2, node3, node4);
        return node;
    }

    Node new35()
    {
        PTypeIdent node5 = (PTypeIdent) pop();
        TColon node4 = (TColon) pop();
        PFormalParamList node3 = (PFormalParamList) pop();
        PIdent node2 = (PIdent) pop();
        TFunction node1 = (TFunction) pop();
        AFuncDeclHead node = new AFuncDeclHead(node1, node2, node3, node4, node5);
        return node;
    }

    Node new36()
    {
        PStdType node1 = (PStdType) pop();
        AStdTypeTypeIdent node = new AStdTypeTypeIdent(node1);
        return node;
    }

    Node new37()
    {
        PIdent node1 = (PIdent) pop();
        AIdentTypeIdent node = new AIdentTypeIdent(node1);
        return node;
    }

    Node new38()
    {
        TTypeInteger node1 = (TTypeInteger) pop();
        ATypeIntegerStdType node = new ATypeIntegerStdType(node1);
        return node;
    }

    Node new39()
    {
        TTypeReal node1 = (TTypeReal) pop();
        ATypeRealStdType node = new ATypeRealStdType(node1);
        return node;
    }

    Node new40()
    {
        TTypeBool node1 = (TTypeBool) pop();
        ATypeBoolStdType node = new ATypeBoolStdType(node1);
        return node;
    }

    Node new41()
    {
        TTypeChar node1 = (TTypeChar) pop();
        ATypeCharStdType node = new ATypeCharStdType(node1);
        return node;
    }

    Node new42()
    {
        TEnd node3 = (TEnd) pop();
        PStmtSeq node2 = (PStmtSeq) pop();
        TBiginn node1 = (TBiginn) pop();
        AStmtPart node = new AStmtPart(node1, node2, node3);
        return node;
    }

    Node new43()
    {
        PTypeIdent node1 = (PTypeIdent) pop();
        ATypeType node = new ATypeType(node1);
        return node;
    }

    Node new44()
    {
        PType node6 = (PType) pop();
        TOf node5 = (TOf) pop();
        TRbra node4 = (TRbra) pop();
        PIndexList node3 = (PIndexList) pop();
        TLbra node2 = (TLbra) pop();
        TArray node1 = (TArray) pop();
        AArrayType node = new AArrayType(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new45()
    {
        TEnd node3 = (TEnd) pop();
        PRecordBodyList node2 = (PRecordBodyList) pop();
        TRecord node1 = (TRecord) pop();
        ARecordType node = new ARecordType(node1, node2, node3);
        return node;
    }

    Node new46()
    {
        PIndex node3 = (PIndex) pop();
        TComma node2 = (TComma) pop();
        PIndexList node1 = (PIndexList) pop();
        AIndexListIndexList node = new AIndexListIndexList(node1, node2, node3);
        return node;
    }

    Node new47()
    {
        PIndex node1 = (PIndex) pop();
        AIndexIndexList node = new AIndexIndexList(node1);
        return node;
    }

    Node new48()
    {
        PConstant node3 = (PConstant) pop();
        TDotdot node2 = (TDotdot) pop();
        PConstant node1 = (PConstant) pop();
        AIndex node = new AIndex(node1, node2, node3);
        return node;
    }

    Node new49()
    {
        PRecordBody node3 = (PRecordBody) pop();
        TSemi node2 = (TSemi) pop();
        PRecordBodyList node1 = (PRecordBodyList) pop();
        ARecordBodyListRecordBodyList node = new ARecordBodyListRecordBodyList(node1, node2, node3);
        return node;
    }

    Node new50()
    {
        PRecordBody node1 = (PRecordBody) pop();
        ARecordBodyRecordBodyList node = new ARecordBodyRecordBodyList(node1);
        return node;
    }

    Node new51()
    {
        PType node3 = (PType) pop();
        TColon node2 = (TColon) pop();
        PIdentList node1 = (PIdentList) pop();
        ARecordBody node = new ARecordBody(node1, node2, node3);
        return node;
    }

    Node new52()
    {
        TRpar node3 = (TRpar) pop();
        PFormalParamDeclList node2 = (PFormalParamDeclList) pop();
        TLpar node1 = (TLpar) pop();
        AFormalParamDeclListFormalParamList node = new AFormalParamDeclListFormalParamList(node1, node2, node3);
        return node;
    }

    Node new53()
    {
        AEmptyFormalParamList node = new AEmptyFormalParamList();
        return node;
    }

    Node new54()
    {
        PFormalParamDecl node3 = (PFormalParamDecl) pop();
        TSemi node2 = (TSemi) pop();
        PFormalParamDeclList node1 = (PFormalParamDeclList) pop();
        AFormalParamDeclListFormalParamDeclList node = new AFormalParamDeclListFormalParamDeclList(node1, node2, node3);
        return node;
    }

    Node new55()
    {
        PFormalParamDecl node1 = (PFormalParamDecl) pop();
        AFormalParamDeclFormalParamDeclList node = new AFormalParamDeclFormalParamDeclList(node1);
        return node;
    }

    Node new56()
    {
        PFormalParamDeclIdentList node2 = (PFormalParamDeclIdentList) pop();
        TVar node1 = (TVar) pop();
        AVarFormalParamDecl node = new AVarFormalParamDecl(node1, node2);
        return node;
    }

    Node new57()
    {
        PFormalParamDeclIdentList node1 = (PFormalParamDeclIdentList) pop();
        AFormalParamDeclIdentListFormalParamDecl node = new AFormalParamDeclIdentListFormalParamDecl(node1);
        return node;
    }

    Node new58()
    {
        PTypeIdent node3 = (PTypeIdent) pop();
        TColon node2 = (TColon) pop();
        PIdentList node1 = (PIdentList) pop();
        AFormalParamDeclIdentList node = new AFormalParamDeclIdentList(node1, node2, node3);
        return node;
    }

    Node new59()
    {
        PStmt node3 = (PStmt) pop();
        TSemi node2 = (TSemi) pop();
        PStmtSeq node1 = (PStmtSeq) pop();
        AStmtSeqStmtSeq node = new AStmtSeqStmtSeq(node1, node2, node3);
        return node;
    }

    Node new60()
    {
        PStmt node1 = (PStmt) pop();
        AStmtStmtSeq node = new AStmtStmtSeq(node1);
        return node;
    }

    Node new61()
    {
        PAssignment node1 = (PAssignment) pop();
        AAssignmentStmt node = new AAssignmentStmt(node1);
        return node;
    }

    Node new62()
    {
        PProcCall node1 = (PProcCall) pop();
        AProcStmt node = new AProcStmt(node1);
        return node;
    }

    Node new63()
    {
        TEnd node3 = (TEnd) pop();
        PStmtSeq node2 = (PStmtSeq) pop();
        TBiginn node1 = (TBiginn) pop();
        AStmtSeqStmt node = new AStmtSeqStmt(node1, node2, node3);
        return node;
    }

    Node new64()
    {
        PCaseStmt node1 = (PCaseStmt) pop();
        ACaseStmtStmt node = new ACaseStmtStmt(node1);
        return node;
    }

    Node new65()
    {
        PWhileStmt node1 = (PWhileStmt) pop();
        AWhileStmtStmt node = new AWhileStmtStmt(node1);
        return node;
    }

    Node new66()
    {
        PRepeatStmt node1 = (PRepeatStmt) pop();
        ARepeatStmtStmt node = new ARepeatStmtStmt(node1);
        return node;
    }

    Node new67()
    {
        PForStmt node1 = (PForStmt) pop();
        AForStmtStmt node = new AForStmtStmt(node1);
        return node;
    }

    Node new68()
    {
        PIfStmt node1 = (PIfStmt) pop();
        AIfStmtStmt node = new AIfStmtStmt(node1);
        return node;
    }

    Node new69()
    {
        AEmptyStmt node = new AEmptyStmt();
        return node;
    }

    Node new70()
    {
        PExpr node4 = (PExpr) pop();
        TColeq node3 = (TColeq) pop();
        PVariableTail node2 = (PVariableTail) pop();
        PIdent node1 = (PIdent) pop();
        AVariableTailAssignment node = new AVariableTailAssignment(node1, node2, node3, node4);
        return node;
    }

    Node new71()
    {
        PExpr node3 = (PExpr) pop();
        TColeq node2 = (TColeq) pop();
        PIdent node1 = (PIdent) pop();
        AColeqAssignment node = new AColeqAssignment(node1, node2, node3);
        return node;
    }

    Node new72()
    {
        PBuiltinProcCall node1 = (PBuiltinProcCall) pop();
        ABuiltinProcCallProcCall node = new ABuiltinProcCallProcCall(node1);
        return node;
    }

    Node new73()
    {
        PActualParamList node2 = (PActualParamList) pop();
        PIdent node1 = (PIdent) pop();
        AActualParamListProcCall node = new AActualParamListProcCall(node1, node2);
        return node;
    }

    Node new74()
    {
        PIdent node1 = (PIdent) pop();
        AIdentProcCall node = new AIdentProcCall(node1);
        return node;
    }

    Node new75()
    {
        PActualParamList node2 = (PActualParamList) pop();
        TRead node1 = (TRead) pop();
        AReadBuiltinProcCall node = new AReadBuiltinProcCall(node1, node2);
        return node;
    }

    Node new76()
    {
        PActualParamList node2 = (PActualParamList) pop();
        TReadln node1 = (TReadln) pop();
        AReadlnBuiltinProcCall node = new AReadlnBuiltinProcCall(node1, node2);
        return node;
    }

    Node new77()
    {
        PActualParamList node2 = (PActualParamList) pop();
        TWrite node1 = (TWrite) pop();
        AWriteBuiltinProcCall node = new AWriteBuiltinProcCall(node1, node2);
        return node;
    }

    Node new78()
    {
        TWriteln node1 = (TWriteln) pop();
        AWritelnBuiltinProcCall node = new AWritelnBuiltinProcCall(node1);
        return node;
    }

    Node new79()
    {
        PActualParamList node2 = (PActualParamList) pop();
        TWriteln node1 = (TWriteln) pop();
        AWritelnlparBuiltinProcCall node = new AWritelnlparBuiltinProcCall(node1, node2);
        return node;
    }

    Node new80()
    {
        PFmatchedStmt node1 = (PFmatchedStmt) pop();
        AMatchedStmtIfStmt node = new AMatchedStmtIfStmt(node1);
        return node;
    }

    Node new81()
    {
        PUnmatchedStmt node1 = (PUnmatchedStmt) pop();
        AUnmatchedStmtIfStmt node = new AUnmatchedStmtIfStmt(node1);
        return node;
    }

    Node new82()
    {
        PSmatchedStmt node6 = (PSmatchedStmt) pop();
        TElse node5 = (TElse) pop();
        PSmatchedStmt node4 = (PSmatchedStmt) pop();
        TThen node3 = (TThen) pop();
        PExpr node2 = (PExpr) pop();
        TIf node1 = (TIf) pop();
        AFmatchedStmt node = new AFmatchedStmt(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new83()
    {
        PIfStmt node4 = (PIfStmt) pop();
        TThen node3 = (TThen) pop();
        PExpr node2 = (PExpr) pop();
        TIf node1 = (TIf) pop();
        AIfthenIfUnmatchedStmt node = new AIfthenIfUnmatchedStmt(node1, node2, node3, node4);
        return node;
    }

    Node new84()
    {
        POther node4 = (POther) pop();
        TThen node3 = (TThen) pop();
        PExpr node2 = (PExpr) pop();
        TIf node1 = (TIf) pop();
        AIfthenUnmatchedStmt node = new AIfthenUnmatchedStmt(node1, node2, node3, node4);
        return node;
    }

    Node new85()
    {
        PUnmatchedStmt node6 = (PUnmatchedStmt) pop();
        TElse node5 = (TElse) pop();
        PSmatchedStmt node4 = (PSmatchedStmt) pop();
        TThen node3 = (TThen) pop();
        PExpr node2 = (PExpr) pop();
        TIf node1 = (TIf) pop();
        AIfthenelseUnmatchedStmt node = new AIfthenelseUnmatchedStmt(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new86()
    {
        PFmatchedStmt node1 = (PFmatchedStmt) pop();
        AFmatchedStmtSmatchedStmt node = new AFmatchedStmtSmatchedStmt(node1);
        return node;
    }

    Node new87()
    {
        POther node1 = (POther) pop();
        AOtherSmatchedStmt node = new AOtherSmatchedStmt(node1);
        return node;
    }

    Node new88()
    {
        PAssignment node1 = (PAssignment) pop();
        AAssignmentOther node = new AAssignmentOther(node1);
        return node;
    }

    Node new89()
    {
        PProcCall node1 = (PProcCall) pop();
        AProcOther node = new AProcOther(node1);
        return node;
    }

    Node new90()
    {
        TEnd node3 = (TEnd) pop();
        PStmtSeq node2 = (PStmtSeq) pop();
        TBiginn node1 = (TBiginn) pop();
        AStmtSeqOther node = new AStmtSeqOther(node1, node2, node3);
        return node;
    }

    Node new91()
    {
        PCaseStmt node1 = (PCaseStmt) pop();
        ACaseStmtOther node = new ACaseStmtOther(node1);
        return node;
    }

    Node new92()
    {
        PRepeatStmt node1 = (PRepeatStmt) pop();
        ARepeatStmtOther node = new ARepeatStmtOther(node1);
        return node;
    }

    Node new93()
    {
        AEmptyOther node = new AEmptyOther();
        return node;
    }

    Node new94()
    {
        TEnd node5 = (TEnd) pop();
        PCaseBodyList node4 = (PCaseBodyList) pop();
        TOf node3 = (TOf) pop();
        PExpr node2 = (PExpr) pop();
        TCase node1 = (TCase) pop();
        ACaseStmt node = new ACaseStmt(node1, node2, node3, node4, node5);
        return node;
    }

    Node new95()
    {
        PCaseBody node3 = (PCaseBody) pop();
        TSemi node2 = (TSemi) pop();
        PCaseBodyList node1 = (PCaseBodyList) pop();
        ACaseBodyListCaseBodyList node = new ACaseBodyListCaseBodyList(node1, node2, node3);
        return node;
    }

    Node new96()
    {
        PCaseBody node1 = (PCaseBody) pop();
        ACaseBodyCaseBodyList node = new ACaseBodyCaseBodyList(node1);
        return node;
    }

    Node new97()
    {
        PStmt node3 = (PStmt) pop();
        TColon node2 = (TColon) pop();
        PCaseLabelList node1 = (PCaseLabelList) pop();
        ACaseLabelListCaseBody node = new ACaseLabelListCaseBody(node1, node2, node3);
        return node;
    }

    Node new98()
    {
        AEmptyCaseBody node = new AEmptyCaseBody();
        return node;
    }

    Node new99()
    {
        PCaseLabel node3 = (PCaseLabel) pop();
        TComma node2 = (TComma) pop();
        PCaseLabelList node1 = (PCaseLabelList) pop();
        ACaseLabelListCaseLabelList node = new ACaseLabelListCaseLabelList(node1, node2, node3);
        return node;
    }

    Node new100()
    {
        PCaseLabel node1 = (PCaseLabel) pop();
        ACaseLabelCaseLabelList node = new ACaseLabelCaseLabelList(node1);
        return node;
    }

    Node new101()
    {
        PConstant node1 = (PConstant) pop();
        ACaseLabel node = new ACaseLabel(node1);
        return node;
    }

    Node new102()
    {
        PStmt node4 = (PStmt) pop();
        TDo node3 = (TDo) pop();
        PExpr node2 = (PExpr) pop();
        TWhile node1 = (TWhile) pop();
        AWhileStmt node = new AWhileStmt(node1, node2, node3, node4);
        return node;
    }

    Node new103()
    {
        PExpr node4 = (PExpr) pop();
        TUntil node3 = (TUntil) pop();
        PStmtSeq node2 = (PStmtSeq) pop();
        TRepeat node1 = (TRepeat) pop();
        ARepeatStmt node = new ARepeatStmt(node1, node2, node3, node4);
        return node;
    }

    Node new104()
    {
        PStmt node8 = (PStmt) pop();
        TDo node7 = (TDo) pop();
        PExpr node6 = (PExpr) pop();
        PDirection node5 = (PDirection) pop();
        PExpr node4 = (PExpr) pop();
        TColeq node3 = (TColeq) pop();
        PIdent node2 = (PIdent) pop();
        TFor node1 = (TFor) pop();
        AForStmt node = new AForStmt(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new105()
    {
        TTo node1 = (TTo) pop();
        AToDirection node = new AToDirection(node1);
        return node;
    }

    Node new106()
    {
        TDownto node1 = (TDownto) pop();
        ADowntoDirection node = new ADowntoDirection(node1);
        return node;
    }

    Node new107()
    {
        TEq node1 = (TEq) pop();
        AEqRelop node = new AEqRelop(node1);
        return node;
    }

    Node new108()
    {
        TNoteq node1 = (TNoteq) pop();
        ANoteqRelop node = new ANoteqRelop(node1);
        return node;
    }

    Node new109()
    {
        TGt node1 = (TGt) pop();
        AGtRelop node = new AGtRelop(node1);
        return node;
    }

    Node new110()
    {
        TLt node1 = (TLt) pop();
        ALtRelop node = new ALtRelop(node1);
        return node;
    }

    Node new111()
    {
        TGe node1 = (TGe) pop();
        AGeRelop node = new AGeRelop(node1);
        return node;
    }

    Node new112()
    {
        TLe node1 = (TLe) pop();
        ALeRelop node = new ALeRelop(node1);
        return node;
    }

    Node new113()
    {
        PSimpleExpr node1 = (PSimpleExpr) pop();
        ASimpleExprExpr node = new ASimpleExprExpr(node1);
        return node;
    }

    Node new114()
    {
        PSimpleExpr node3 = (PSimpleExpr) pop();
        PRelop node2 = (PRelop) pop();
        PSimpleExpr node1 = (PSimpleExpr) pop();
        ASimpleExprrelopsimpleExprExpr node = new ASimpleExprrelopsimpleExprExpr(node1, node2, node3);
        return node;
    }

    Node new115()
    {
        PTerm node1 = (PTerm) pop();
        ATermSimpleExpr node = new ATermSimpleExpr(node1);
        return node;
    }

    Node new116()
    {
        PTerm node2 = (PTerm) pop();
        PUnop node1 = (PUnop) pop();
        AUnoptermSimpleExpr node = new AUnoptermSimpleExpr(node1, node2);
        return node;
    }

    Node new117()
    {
        PTerm node3 = (PTerm) pop();
        PLowOp node2 = (PLowOp) pop();
        PSimpleExpr node1 = (PSimpleExpr) pop();
        ASimpleExprlowOptermSimpleExpr node = new ASimpleExprlowOptermSimpleExpr(node1, node2, node3);
        return node;
    }

    Node new118()
    {
        PTerm node3 = (PTerm) pop();
        POrOp node2 = (POrOp) pop();
        PSimpleExpr node1 = (PSimpleExpr) pop();
        ASimpleExprorOptermSimpleExpr node = new ASimpleExprorOptermSimpleExpr(node1, node2, node3);
        return node;
    }

    Node new119()
    {
        PFact node1 = (PFact) pop();
        AFactTerm node = new AFactTerm(node1);
        return node;
    }

    Node new120()
    {
        PFact node3 = (PFact) pop();
        PHighOp node2 = (PHighOp) pop();
        PTerm node1 = (PTerm) pop();
        ATermhighOpfactTerm node = new ATermhighOpfactTerm(node1, node2, node3);
        return node;
    }

    Node new121()
    {
        PFact node3 = (PFact) pop();
        PAndOp node2 = (PAndOp) pop();
        PTerm node1 = (PTerm) pop();
        ATermandOpfactTerm node = new ATermandOpfactTerm(node1, node2, node3);
        return node;
    }

    Node new122()
    {
        PUnsignedConstant node1 = (PUnsignedConstant) pop();
        AUnsignedConstantFact node = new AUnsignedConstantFact(node1);
        return node;
    }

    Node new123()
    {
        PIdent node1 = (PIdent) pop();
        AIdentFact node = new AIdentFact(node1);
        return node;
    }

    Node new124()
    {
        PVariableTail node2 = (PVariableTail) pop();
        PIdent node1 = (PIdent) pop();
        AVariableTailFact node = new AVariableTailFact(node1, node2);
        return node;
    }

    Node new125()
    {
        PFuncCallWithParam node1 = (PFuncCallWithParam) pop();
        AFuncCallWithParamFact node = new AFuncCallWithParamFact(node1);
        return node;
    }

    Node new126()
    {
        TRpar node3 = (TRpar) pop();
        PExpr node2 = (PExpr) pop();
        TLpar node1 = (TLpar) pop();
        ALparexprrparFact node = new ALparexprrparFact(node1, node2, node3);
        return node;
    }

    Node new127()
    {
        PFact node2 = (PFact) pop();
        TNot node1 = (TNot) pop();
        ANotfactFact node = new ANotfactFact(node1, node2);
        return node;
    }

    Node new128()
    {
        TPlus node1 = (TPlus) pop();
        APlusUnop node = new APlusUnop(node1);
        return node;
    }

    Node new129()
    {
        TMinus node1 = (TMinus) pop();
        AMinusUnop node = new AMinusUnop(node1);
        return node;
    }

    Node new130()
    {
        TPlus node1 = (TPlus) pop();
        APlusLowOp node = new APlusLowOp(node1);
        return node;
    }

    Node new131()
    {
        TMinus node1 = (TMinus) pop();
        AMinusLowOp node = new AMinusLowOp(node1);
        return node;
    }

    Node new132()
    {
        TOr node1 = (TOr) pop();
        AOrOp node = new AOrOp(node1);
        return node;
    }

    Node new133()
    {
        TMult node1 = (TMult) pop();
        AMultHighOp node = new AMultHighOp(node1);
        return node;
    }

    Node new134()
    {
        TSlash node1 = (TSlash) pop();
        ASlashHighOp node = new ASlashHighOp(node1);
        return node;
    }

    Node new135()
    {
        TDiv node1 = (TDiv) pop();
        ADivHighOp node = new ADivHighOp(node1);
        return node;
    }

    Node new136()
    {
        TMod node1 = (TMod) pop();
        AModHighOp node = new AModHighOp(node1);
        return node;
    }

    Node new137()
    {
        TAnd node1 = (TAnd) pop();
        AAndOp node = new AAndOp(node1);
        return node;
    }

    Node new138()
    {
        PBuiltinFuncCall node1 = (PBuiltinFuncCall) pop();
        ABuiltinFuncCallFuncCallWithParam node = new ABuiltinFuncCallFuncCallWithParam(node1);
        return node;
    }

    Node new139()
    {
        PActualParamList node2 = (PActualParamList) pop();
        PIdent node1 = (PIdent) pop();
        AIdentFuncCallWithParam node = new AIdentFuncCallWithParam(node1, node2);
        return node;
    }

    Node new140()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TSin node1 = (TSin) pop();
        ASinBuiltinFuncCall node = new ASinBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new141()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TCos node1 = (TCos) pop();
        ACosBuiltinFuncCall node = new ACosBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new142()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TOdd node1 = (TOdd) pop();
        AOddBuiltinFuncCall node = new AOddBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new143()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TEven node1 = (TEven) pop();
        AEvenBuiltinFuncCall node = new AEvenBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new144()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TSqr node1 = (TSqr) pop();
        ASqrBuiltinFuncCall node = new ASqrBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new145()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFArctan node1 = (TFArctan) pop();
        AFArctanBuiltinFuncCall node = new AFArctanBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new146()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFSqrt node1 = (TFSqrt) pop();
        AFSqrtBuiltinFuncCall node = new AFSqrtBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new147()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFAbs node1 = (TFAbs) pop();
        AFAbsBuiltinFuncCall node = new AFAbsBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new148()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFRound node1 = (TFRound) pop();
        AFRoundBuiltinFuncCall node = new AFRoundBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new149()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFTrunc node1 = (TFTrunc) pop();
        AFTruncBuiltinFuncCall node = new AFTruncBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new150()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFExp node1 = (TFExp) pop();
        AFExpBuiltinFuncCall node = new AFExpBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new151()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFLn node1 = (TFLn) pop();
        AFLnBuiltinFuncCall node = new AFLnBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new152()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFChr node1 = (TFChr) pop();
        AFChrBuiltinFuncCall node = new AFChrBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new153()
    {
        TRpar node4 = (TRpar) pop();
        PExpr node3 = (PExpr) pop();
        TLpar node2 = (TLpar) pop();
        TFOrd node1 = (TFOrd) pop();
        AFOrdBuiltinFuncCall node = new AFOrdBuiltinFuncCall(node1, node2, node3, node4);
        return node;
    }

    Node new154()
    {
        TFEof node1 = (TFEof) pop();
        AFEofBuiltinFuncCall node = new AFEofBuiltinFuncCall(node1);
        return node;
    }

    Node new155()
    {
        TFEoln node1 = (TFEoln) pop();
        AFEolnBuiltinFuncCall node = new AFEolnBuiltinFuncCall(node1);
        return node;
    }

    Node new156()
    {
        TRpar node3 = (TRpar) pop();
        PArgList node2 = (PArgList) pop();
        TLpar node1 = (TLpar) pop();
        AActualParamList node = new AActualParamList(node1, node2, node3);
        return node;
    }

    Node new157()
    {
        PExpr node3 = (PExpr) pop();
        TComma node2 = (TComma) pop();
        PArgList node1 = (PArgList) pop();
        AArgListArgList node = new AArgListArgList(node1, node2, node3);
        return node;
    }

    Node new158()
    {
        PExpr node1 = (PExpr) pop();
        AExprArgList node = new AExprArgList(node1);
        return node;
    }

    Node new159()
    {
        PCustomTypeTail node4 = (PCustomTypeTail) pop();
        TRbra node3 = (TRbra) pop();
        PSubscriptList node2 = (PSubscriptList) pop();
        TLbra node1 = (TLbra) pop();
        ASubscriptListVariableTail node = new ASubscriptListVariableTail(node1, node2, node3, node4);
        return node;
    }

    Node new160()
    {
        PCustomTypeTail node3 = (PCustomTypeTail) pop();
        PIdent node2 = (PIdent) pop();
        TDot node1 = (TDot) pop();
        AFieldIdentVariableTail node = new AFieldIdentVariableTail(node1, node2, node3);
        return node;
    }

    Node new161()
    {
        PVariableTail node1 = (PVariableTail) pop();
        AVariableTailCustomTypeTail node = new AVariableTailCustomTypeTail(node1);
        return node;
    }

    Node new162()
    {
        AEmptyCustomTypeTail node = new AEmptyCustomTypeTail();
        return node;
    }

    Node new163()
    {
        PExpr node3 = (PExpr) pop();
        TComma node2 = (TComma) pop();
        PSubscriptList node1 = (PSubscriptList) pop();
        ASubscriptListSubscriptList node = new ASubscriptListSubscriptList(node1, node2, node3);
        return node;
    }

    Node new164()
    {
        PExpr node1 = (PExpr) pop();
        AExprSubscriptList node = new AExprSubscriptList(node1);
        return node;
    }

    Node new165()
    {
        PNumberConst node1 = (PNumberConst) pop();
        ANumberConstConstant node = new ANumberConstConstant(node1);
        return node;
    }

    Node new166()
    {
        PIdent node1 = (PIdent) pop();
        AIdentConstant node = new AIdentConstant(node1);
        return node;
    }

    Node new167()
    {
        PIdent node2 = (PIdent) pop();
        PUnop node1 = (PUnop) pop();
        AUnopConstant node = new AUnopConstant(node1, node2);
        return node;
    }

    Node new168()
    {
        PCharConst node1 = (PCharConst) pop();
        ACharConstConstant node = new ACharConstConstant(node1);
        return node;
    }

    Node new169()
    {
        PUnsignedNumber node1 = (PUnsignedNumber) pop();
        AUnsignedNumberNumberConst node = new AUnsignedNumberNumberConst(node1);
        return node;
    }

    Node new170()
    {
        PUnsignedNumber node2 = (PUnsignedNumber) pop();
        PUnop node1 = (PUnop) pop();
        AUnopNumberConst node = new AUnopNumberConst(node1, node2);
        return node;
    }

    Node new171()
    {
        PNumber node1 = (PNumber) pop();
        AUnsignedNumber node = new AUnsignedNumber(node1);
        return node;
    }

    Node new172()
    {
        TReal node1 = (TReal) pop();
        ARealNumber node = new ARealNumber(node1);
        return node;
    }

    Node new173()
    {
        TInteger node1 = (TInteger) pop();
        AIntegerNumber node = new AIntegerNumber(node1);
        return node;
    }

    Node new174()
    {
        PCharacter node1 = (PCharacter) pop();
        ACharConst node = new ACharConst(node1);
        return node;
    }

    Node new175()
    {
        TChar node1 = (TChar) pop();
        ACharacter node = new ACharacter(node1);
        return node;
    }

    Node new176()
    {
        PUnsignedNumber node1 = (PUnsignedNumber) pop();
        AUnsignedNumberUnsignedConstant node = new AUnsignedNumberUnsignedConstant(node1);
        return node;
    }

    Node new177()
    {
        PCharConst node1 = (PCharConst) pop();
        ACharConstUnsignedConstant node = new ACharConstUnsignedConstant(node1);
        return node;
    }

    Node new178()
    {
        TBTrue node1 = (TBTrue) pop();
        ABTrueUnsignedConstant node = new ABTrueUnsignedConstant(node1);
        return node;
    }

    Node new179()
    {
        TBFalse node1 = (TBFalse) pop();
        ABFalseUnsignedConstant node = new ABFalseUnsignedConstant(node1);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {56, SHIFT, 1}, },
			{{-1, ERROR, 1}, {79, SHIFT, 4}, },
			{{-1, ERROR, 2}, {81, ACCEPT, -1}, },
			{{-1, ERROR, 3}, {11, SHIFT, 6}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 5}, {0, SHIFT, 7}, },
			{{-1, REDUCE, 9}, {29, SHIFT, 8}, },
			{{-1, ERROR, 7}, {44, SHIFT, 14}, {53, SHIFT, 15}, },
			{{-1, ERROR, 8}, {79, SHIFT, 4}, },
			{{-1, ERROR, 9}, {6, SHIFT, 20}, },
			{{-1, ERROR, 10}, {24, SHIFT, 21}, },
			{{-1, REDUCE, 27}, {42, SHIFT, 23}, {55, SHIFT, 24}, },
			{{-1, REDUCE, 19}, {73, SHIFT, 32}, },
			{{-1, REDUCE, 14}, {71, SHIFT, 34}, },
			{{-1, ERROR, 14}, {4, SHIFT, 36}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 16}, {1, SHIFT, 37}, },
			{{-1, ERROR, 17}, {11, SHIFT, 38}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 19}, {15, SHIFT, 39}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 23}, {79, SHIFT, 4}, },
			{{-1, ERROR, 24}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 26}, {42, SHIFT, 23}, {55, SHIFT, 24}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 29}, {11, SHIFT, 66}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 31}, {11, SHIFT, 67}, },
			{{-1, ERROR, 32}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 34}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 36}, {53, SHIFT, 75}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 8}, {79, SHIFT, 4}, },
			{{-1, ERROR, 39}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, ERROR, 41}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 42}, {79, SHIFT, 4}, },
			{{-1, ERROR, 43}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 44}, {0, SHIFT, 124}, },
			{{-1, ERROR, 45}, {0, SHIFT, 124}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, ERROR, 47}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 48}, {0, SHIFT, 124}, },
			{{-1, REDUCE, 78}, {0, SHIFT, 124}, },
			{{-1, REDUCE, 74}, {0, SHIFT, 124}, {6, SHIFT, 131}, {10, SHIFT, 132}, {18, SHIFT, 133}, },
			{{-1, ERROR, 51}, {11, SHIFT, 136}, {35, SHIFT, 137}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 80}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 65}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 53}, {0, SHIFT, 138}, },
			{{-1, REDUCE, 53}, {0, SHIFT, 138}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 9}, {29, SHIFT, 8}, },
			{{-1, REDUCE, 9}, {29, SHIFT, 8}, },
			{{-1, ERROR, 68}, {11, SHIFT, 143}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 70}, {4, SHIFT, 144}, {9, SHIFT, 145}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 72}, {11, SHIFT, 146}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 74}, {15, SHIFT, 147}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 128}, },
			{{-1, REDUCE, 129}, },
			{{-1, REDUCE, 172}, },
			{{-1, REDUCE, 173}, },
			{{-1, REDUCE, 175}, },
			{{-1, REDUCE, 166}, },
			{{-1, ERROR, 83}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 165}, },
			{{-1, REDUCE, 169}, },
			{{-1, REDUCE, 171}, },
			{{-1, REDUCE, 168}, },
			{{-1, REDUCE, 174}, },
			{{-1, ERROR, 90}, {11, SHIFT, 136}, {35, SHIFT, 150}, },
			{{-1, ERROR, 91}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 92}, {0, SHIFT, 152}, },
			{{-1, ERROR, 93}, {0, SHIFT, 153}, },
			{{-1, ERROR, 94}, {0, SHIFT, 154}, },
			{{-1, ERROR, 95}, {0, SHIFT, 155}, },
			{{-1, REDUCE, 154}, },
			{{-1, REDUCE, 155}, },
			{{-1, ERROR, 98}, {0, SHIFT, 156}, },
			{{-1, ERROR, 99}, {0, SHIFT, 157}, },
			{{-1, REDUCE, 179}, },
			{{-1, ERROR, 101}, {0, SHIFT, 158}, },
			{{-1, ERROR, 102}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 103}, {0, SHIFT, 160}, },
			{{-1, ERROR, 104}, {0, SHIFT, 161}, },
			{{-1, ERROR, 105}, {0, SHIFT, 162}, },
			{{-1, ERROR, 106}, {0, SHIFT, 163}, },
			{{-1, ERROR, 107}, {0, SHIFT, 164}, },
			{{-1, ERROR, 108}, {0, SHIFT, 165}, },
			{{-1, REDUCE, 178}, },
			{{-1, ERROR, 110}, {0, SHIFT, 166}, },
			{{-1, REDUCE, 123}, {0, SHIFT, 124}, {6, SHIFT, 131}, {18, SHIFT, 133}, },
			{{-1, ERROR, 112}, {50, SHIFT, 169}, },
			{{-1, REDUCE, 113}, {3, SHIFT, 170}, {5, SHIFT, 171}, {12, SHIFT, 172}, {13, SHIFT, 173}, {14, SHIFT, 174}, {15, SHIFT, 175}, {16, SHIFT, 176}, {17, SHIFT, 177}, {51, SHIFT, 178}, },
			{{-1, REDUCE, 115}, {2, SHIFT, 182}, {8, SHIFT, 183}, {22, SHIFT, 184}, {31, SHIFT, 185}, {47, SHIFT, 186}, },
			{{-1, REDUCE, 119}, },
			{{-1, ERROR, 116}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 125}, },
			{{-1, REDUCE, 138}, },
			{{-1, REDUCE, 176}, },
			{{-1, REDUCE, 177}, },
			{{-1, REDUCE, 122}, },
			{{-1, ERROR, 122}, {10, SHIFT, 190}, },
			{{-1, ERROR, 123}, {67, SHIFT, 191}, },
			{{-1, ERROR, 124}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 76}, },
			{{-1, ERROR, 127}, {11, SHIFT, 136}, {72, SHIFT, 194}, },
			{{-1, ERROR, 128}, {32, SHIFT, 195}, },
			{{-1, REDUCE, 77}, },
			{{-1, REDUCE, 79}, },
			{{-1, ERROR, 131}, {79, SHIFT, 4}, },
			{{-1, ERROR, 132}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 133}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 73}, },
			{{-1, ERROR, 135}, {10, SHIFT, 200}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 138}, {73, SHIFT, 202}, {79, SHIFT, 4}, },
			{{-1, ERROR, 139}, {9, SHIFT, 207}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 141}, {11, SHIFT, 208}, },
			{{-1, ERROR, 142}, {11, SHIFT, 209}, },
			{{-1, REDUCE, 18}, {79, SHIFT, 4}, },
			{{-1, ERROR, 144}, {79, SHIFT, 4}, },
			{{-1, ERROR, 145}, {23, SHIFT, 212}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {60, SHIFT, 217}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 13}, {79, SHIFT, 4}, },
			{{-1, ERROR, 147}, {23, SHIFT, 212}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {60, SHIFT, 217}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 167}, },
			{{-1, REDUCE, 170}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 151}, {1, SHIFT, 224}, },
			{{-1, ERROR, 152}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 153}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 154}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 155}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 156}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 157}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 158}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 127}, },
			{{-1, ERROR, 160}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 161}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 162}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 163}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 164}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 165}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 166}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 139}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 98}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 130}, },
			{{-1, REDUCE, 131}, },
			{{-1, REDUCE, 110}, },
			{{-1, REDUCE, 112}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 107}, },
			{{-1, REDUCE, 109}, },
			{{-1, REDUCE, 111}, },
			{{-1, REDUCE, 132}, },
			{{-1, ERROR, 179}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 180}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 181}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 133}, },
			{{-1, REDUCE, 134}, },
			{{-1, REDUCE, 137}, },
			{{-1, REDUCE, 135}, },
			{{-1, REDUCE, 136}, },
			{{-1, ERROR, 187}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 188}, {0, SHIFT, 91}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 116}, {2, SHIFT, 182}, {8, SHIFT, 183}, {22, SHIFT, 184}, {31, SHIFT, 185}, {47, SHIFT, 186}, },
			{{-1, ERROR, 190}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 93}, {24, SHIFT, 250}, {26, SHIFT, 41}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 158}, },
			{{-1, ERROR, 193}, {1, SHIFT, 259}, {4, SHIFT, 260}, },
			{{-1, ERROR, 194}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 162}, {6, SHIFT, 131}, {18, SHIFT, 133}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 164}, },
			{{-1, ERROR, 199}, {4, SHIFT, 265}, {19, SHIFT, 266}, },
			{{-1, ERROR, 200}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 59}, },
			{{-1, ERROR, 202}, {79, SHIFT, 4}, },
			{{-1, ERROR, 203}, {4, SHIFT, 144}, {9, SHIFT, 269}, },
			{{-1, ERROR, 204}, {1, SHIFT, 270}, {11, SHIFT, 271}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 207}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 212}, {18, SHIFT, 273}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 39}, },
			{{-1, ERROR, 217}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 36}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 126}, },
			{{-1, ERROR, 225}, {1, SHIFT, 277}, },
			{{-1, ERROR, 226}, {1, SHIFT, 278}, },
			{{-1, ERROR, 227}, {1, SHIFT, 279}, },
			{{-1, ERROR, 228}, {1, SHIFT, 280}, },
			{{-1, ERROR, 229}, {1, SHIFT, 281}, },
			{{-1, ERROR, 230}, {1, SHIFT, 282}, },
			{{-1, ERROR, 231}, {1, SHIFT, 283}, },
			{{-1, ERROR, 232}, {1, SHIFT, 284}, },
			{{-1, ERROR, 233}, {1, SHIFT, 285}, },
			{{-1, ERROR, 234}, {1, SHIFT, 286}, },
			{{-1, ERROR, 235}, {1, SHIFT, 287}, },
			{{-1, ERROR, 236}, {1, SHIFT, 288}, },
			{{-1, ERROR, 237}, {1, SHIFT, 289}, },
			{{-1, ERROR, 238}, {1, SHIFT, 290}, },
			{{-1, ERROR, 239}, {11, SHIFT, 291}, {35, SHIFT, 292}, },
			{{-1, REDUCE, 96}, },
			{{-1, ERROR, 241}, {4, SHIFT, 293}, {9, SHIFT, 294}, },
			{{-1, REDUCE, 100}, },
			{{-1, REDUCE, 101}, },
			{{-1, REDUCE, 114}, {3, SHIFT, 170}, {5, SHIFT, 171}, {51, SHIFT, 178}, },
			{{-1, REDUCE, 117}, {2, SHIFT, 182}, {8, SHIFT, 183}, {22, SHIFT, 184}, {31, SHIFT, 185}, {47, SHIFT, 186}, },
			{{-1, REDUCE, 118}, {2, SHIFT, 182}, {8, SHIFT, 183}, {22, SHIFT, 184}, {31, SHIFT, 185}, {47, SHIFT, 186}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 121}, },
			{{-1, ERROR, 249}, {33, SHIFT, 295}, {68, SHIFT, 296}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 88}, },
			{{-1, REDUCE, 89}, },
			{{-1, REDUCE, 83}, },
			{{-1, REDUCE, 80}, {34, REDUCE, 86}, },
			{{-1, ERROR, 255}, {34, SHIFT, 299}, },
			{{-1, REDUCE, 84}, {34, REDUCE, 87}, },
			{{-1, REDUCE, 91}, },
			{{-1, REDUCE, 92}, },
			{{-1, REDUCE, 156}, },
			{{-1, ERROR, 260}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 103}, },
			{{-1, REDUCE, 102}, },
			{{-1, REDUCE, 161}, },
			{{-1, REDUCE, 160}, },
			{{-1, ERROR, 265}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 162}, {6, SHIFT, 131}, {18, SHIFT, 133}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 56}, },
			{{-1, ERROR, 269}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 271}, {73, SHIFT, 202}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 273}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 274}, {4, SHIFT, 144}, {9, SHIFT, 308}, },
			{{-1, ERROR, 275}, {11, SHIFT, 309}, {35, SHIFT, 310}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 145}, },
			{{-1, REDUCE, 147}, },
			{{-1, REDUCE, 152}, },
			{{-1, REDUCE, 141}, },
			{{-1, REDUCE, 143}, },
			{{-1, REDUCE, 150}, },
			{{-1, REDUCE, 151}, },
			{{-1, REDUCE, 142}, },
			{{-1, REDUCE, 153}, },
			{{-1, REDUCE, 148}, },
			{{-1, REDUCE, 140}, },
			{{-1, REDUCE, 144}, },
			{{-1, REDUCE, 146}, },
			{{-1, REDUCE, 149}, },
			{{-1, REDUCE, 98}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 94}, },
			{{-1, ERROR, 293}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 106}, },
			{{-1, REDUCE, 105}, },
			{{-1, ERROR, 297}, {0, SHIFT, 91}, {3, SHIFT, 77}, {5, SHIFT, 78}, {20, SHIFT, 92}, {21, SHIFT, 93}, {28, SHIFT, 94}, {30, SHIFT, 95}, {36, SHIFT, 96}, {37, SHIFT, 97}, {38, SHIFT, 98}, {39, SHIFT, 99}, {40, SHIFT, 100}, {46, SHIFT, 101}, {48, SHIFT, 102}, {49, SHIFT, 103}, {52, SHIFT, 104}, {62, SHIFT, 105}, {63, SHIFT, 106}, {64, SHIFT, 107}, {65, SHIFT, 108}, {69, SHIFT, 109}, {70, SHIFT, 110}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 298}, {11, SHIFT, 136}, {35, SHIFT, 315}, },
			{{-1, REDUCE, 93}, {24, SHIFT, 250}, {26, SHIFT, 41}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 157}, },
			{{-1, REDUCE, 163}, },
			{{-1, REDUCE, 159}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 305}, {4, SHIFT, 320}, {19, SHIFT, 321}, },
			{{-1, REDUCE, 47}, },
			{{-1, ERROR, 307}, {7, SHIFT, 322}, },
			{{-1, ERROR, 308}, {23, SHIFT, 212}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {60, SHIFT, 217}, {79, SHIFT, 4}, },
			{{-1, ERROR, 309}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 99}, },
			{{-1, REDUCE, 97}, },
			{{-1, ERROR, 314}, {32, SHIFT, 325}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 86}, },
			{{-1, REDUCE, 85}, },
			{{-1, REDUCE, 82}, },
			{{-1, REDUCE, 87}, },
			{{-1, ERROR, 320}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, ERROR, 321}, {50, SHIFT, 327}, },
			{{-1, ERROR, 322}, {3, SHIFT, 77}, {5, SHIFT, 78}, {77, SHIFT, 79}, {78, SHIFT, 80}, {79, SHIFT, 4}, {80, SHIFT, 81}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 69}, {24, SHIFT, 40}, {26, SHIFT, 41}, {41, SHIFT, 42}, {43, SHIFT, 43}, {57, SHIFT, 44}, {58, SHIFT, 45}, {61, SHIFT, 46}, {74, SHIFT, 47}, {75, SHIFT, 48}, {76, SHIFT, 49}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 327}, {23, SHIFT, 212}, {25, SHIFT, 213}, {27, SHIFT, 214}, {45, SHIFT, 215}, {59, SHIFT, 216}, {60, SHIFT, 217}, {79, SHIFT, 4}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 104}, },
			{{-1, REDUCE, 44}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 2}, },
			{{-1, 3}, },
			{{-1, 16}, },
			{{-1, 9}, {66, 141}, {67, 142}, },
			{{-1, 10}, },
			{{-1, 11}, },
			{{-1, 12}, },
			{{-1, 13}, },
			{{-1, 17}, },
			{{-1, 18}, {38, 76}, },
			{{-1, 35}, },
			{{-1, 72}, },
			{{-1, 73}, {146, 222}, },
			{{-1, 33}, },
			{{-1, 68}, },
			{{-1, 69}, {143, 210}, },
			{{-1, 203}, {32, 70}, {143, 70}, {217, 274}, {309, 274}, },
			{{-1, 111}, {1, 5}, {8, 19}, {21, 50}, {23, 63}, {24, 64}, {32, 71}, {34, 74}, {38, 19}, {39, 82}, {40, 50}, {42, 122}, {46, 50}, {83, 148}, {131, 196}, {136, 50}, {138, 71}, {143, 71}, {144, 211}, {145, 218}, {146, 74}, {147, 218}, {169, 82}, {191, 50}, {195, 50}, {202, 71}, {207, 218}, {217, 71}, {250, 50}, {269, 218}, {271, 71}, {273, 82}, {291, 82}, {293, 82}, {294, 50}, {299, 50}, {308, 218}, {309, 71}, {320, 82}, {322, 82}, {325, 50}, {327, 218}, },
			{{-1, 25}, },
			{{-1, 26}, },
			{{-1, 27}, {26, 65}, },
			{{-1, 28}, },
			{{-1, 29}, },
			{{-1, 30}, },
			{{-1, 31}, },
			{{-1, 219}, {207, 272}, {269, 303}, },
			{{-1, 220}, },
			{{-1, 22}, },
			{{-1, 221}, {147, 223}, {308, 323}, {327, 330}, },
			{{-1, 305}, },
			{{-1, 306}, {320, 326}, },
			{{-1, 275}, },
			{{-1, 276}, {309, 324}, },
			{{-1, 139}, {64, 140}, },
			{{-1, 204}, },
			{{-1, 205}, {271, 304}, },
			{{-1, 206}, {202, 268}, },
			{{-1, 51}, {40, 90}, {46, 127}, {250, 298}, },
			{{-1, 52}, {136, 201}, {195, 262}, {294, 313}, {325, 329}, },
			{{-1, 53}, {191, 251}, {299, 251}, },
			{{-1, 54}, {191, 252}, {299, 252}, },
			{{-1, 55}, },
			{{-1, 56}, {191, 253}, },
			{{-1, 57}, {191, 254}, {299, 316}, },
			{{-1, 58}, {299, 317}, },
			{{-1, 255}, {299, 318}, },
			{{-1, 256}, {299, 319}, },
			{{-1, 59}, {191, 257}, {299, 257}, },
			{{-1, 239}, },
			{{-1, 240}, {291, 311}, },
			{{-1, 241}, },
			{{-1, 242}, {293, 312}, },
			{{-1, 60}, },
			{{-1, 61}, {191, 258}, {299, 258}, },
			{{-1, 62}, },
			{{-1, 297}, },
			{{-1, 179}, },
			{{-1, 112}, {43, 123}, {47, 128}, {91, 151}, {124, 192}, {132, 197}, {133, 198}, {152, 225}, {153, 226}, {154, 227}, {155, 228}, {156, 229}, {157, 230}, {158, 231}, {160, 232}, {161, 233}, {162, 234}, {163, 235}, {164, 236}, {165, 237}, {166, 238}, {190, 249}, {194, 261}, {200, 267}, {260, 300}, {265, 301}, {297, 314}, },
			{{-1, 113}, {179, 244}, },
			{{-1, 114}, {116, 189}, {180, 245}, {181, 246}, },
			{{-1, 115}, {102, 159}, {187, 247}, {188, 248}, },
			{{-1, 116}, {39, 83}, {169, 83}, {273, 83}, {291, 83}, {293, 83}, {320, 83}, {322, 83}, },
			{{-1, 180}, },
			{{-1, 181}, },
			{{-1, 187}, },
			{{-1, 188}, },
			{{-1, 117}, },
			{{-1, 118}, },
			{{-1, 125}, {45, 126}, {48, 129}, {49, 130}, {50, 134}, {111, 167}, },
			{{-1, 193}, },
			{{-1, 263}, {50, 135}, {111, 168}, },
			{{-1, 264}, {266, 302}, },
			{{-1, 199}, },
			{{-1, 243}, {39, 84}, {273, 307}, {320, 307}, {322, 328}, },
			{{-1, 85}, },
			{{-1, 119}, {39, 86}, {83, 149}, {169, 86}, {273, 86}, {291, 86}, {293, 86}, {320, 86}, {322, 86}, },
			{{-1, 87}, },
			{{-1, 120}, {39, 88}, {169, 88}, {273, 88}, {291, 88}, {293, 88}, {320, 88}, {322, 88}, },
			{{-1, 89}, },
			{{-1, 121}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'program'",
			"expecting: identt",
			"expecting: EOF",
			"expecting: ';'",
			"expecting: '(', ')', '*', '+', ',', '-', '.', '..', '/', ':', ':=', ';', '<', '<=', '<>', '=', '>', '>=', '[', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: '('",
			"expecting: 'begin', 'const', 'function', 'procedure', 'type', 'var'",
			"expecting: 'input', 'output'",
			"expecting: '.'",
			"expecting: 'begin'",
			"expecting: 'begin', 'function', 'procedure'",
			"expecting: 'begin', 'function', 'procedure', 'var'",
			"expecting: 'begin', 'function', 'procedure', 'type', 'var'",
			"expecting: ','",
			"expecting: ')'",
			"expecting: '='",
			"expecting: ';', 'begin', 'case', 'end', 'for', 'if', 'read', 'readln', 'repeat', 'while', 'write', 'writeln', identt",
			"expecting: '.', ';'",
			"expecting: 'output'",
			"expecting: 'begin', 'function', 'procedure', 'type', 'var', identt",
			"expecting: '+', '-', real, integer, identt, char",
			"expecting: '(', '+', '-', 'arctan', 'abs', 'chr', 'cos', 'eof', 'eoln', 'even', 'exp', 'false', 'ln', 'not', 'odd', 'ord', 'round', 'sin', 'sqr', 'sqrt', 'true', 'trunc', real, integer, identt, char",
			"expecting: ';', 'begin', 'case', 'for', 'if', 'read', 'readln', 'repeat', 'until', 'while', 'write', 'writeln', identt",
			"expecting: '(', ';', 'else', 'end', 'until'",
			"expecting: '(', '.', ':=', ';', '[', 'else', 'end', 'until'",
			"expecting: ';', 'end'",
			"expecting: ';', 'end', 'until'",
			"expecting: ';', 'else', 'end', 'until'",
			"expecting: '(', ':'",
			"expecting: '(', ';'",
			"expecting: ',', ':'",
			"expecting: '(', 'arctan', 'abs', 'chr', 'cos', 'eof', 'eoln', 'even', 'exp', 'false', 'ln', 'not', 'odd', 'ord', 'round', 'sin', 'sqr', 'sqrt', 'true', 'trunc', real, integer, identt, char",
			"expecting: ')', '*', '+', ',', '-', '..', '/', ':', ';', '<', '<=', '<>', '=', '>', '>=', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: ',', '..', ':', ';', ']'",
			"expecting: real, integer, identt",
			"expecting: ')', '*', '+', ',', '-', '/', ';', '<', '<=', '<>', '=', '>', '>=', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: '(', ')', '*', '+', ',', '-', '.', '/', ';', '<', '<=', '<>', '=', '>', '>=', '[', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: 'of'",
			"expecting: ')', '+', ',', '-', ';', '<', '<=', '<>', '=', '>', '>=', ']', 'do', 'downto', 'else', 'end', 'of', 'or', 'then', 'to', 'until'",
			"expecting: ':='",
			"expecting: 'then'",
			"expecting: ';', 'until'",
			"expecting: 'do'",
			"expecting: ';', 'begin', 'case', 'end', 'for', 'if', 'read', 'readln', 'repeat', 'until', 'while', 'write', 'writeln', identt",
			"expecting: 'var', identt",
			"expecting: ':'",
			"expecting: 'begin', 'function', 'procedure', identt",
			"expecting: 'array', 'boolean', 'char', 'integer', 'real', 'record', identt",
			"expecting: 'begin', 'function', 'procedure', 'var', identt",
			"expecting: '+', '-', ';', 'end', real, integer, identt, char",
			"expecting: ';', 'begin', 'case', 'else', 'end', 'if', 'read', 'readln', 'repeat', 'until', 'write', 'writeln', identt",
			"expecting: ')', ','",
			"expecting: ')', '*', '+', ',', '-', '.', '/', ':=', ';', '<', '<=', '<>', '=', '>', '>=', '[', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: ',', ']'",
			"expecting: ')', ';'",
			"expecting: 'boolean', 'char', 'integer', 'real', identt",
			"expecting: '['",
			"expecting: ')', ';', 'end'",
			"expecting: ')', '+', ',', '-', ';', ']', 'do', 'downto', 'else', 'end', 'of', 'or', 'then', 'to', 'until'",
			"expecting: 'downto', 'to'",
			"expecting: 'else'",
			"expecting: ')', '*', '+', ',', '-', '/', ':=', ';', '<', '<=', '<>', '=', '>', '>=', ']', 'and', 'div', 'do', 'downto', 'else', 'end', 'mod', 'of', 'or', 'then', 'to', 'until'",
			"expecting: ':', ';'",
			"expecting: '..'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 4, 5, 6, 7, 1, 8, 9, 10, 11, 12, 13, 14, 14, 3, 3, 15, 2, 16, 17, 1, 1, 9, 10, 10, 10, 3, 10, 3, 1, 10, 1, 11, 18, 3, 19, 20, 16, 21, 1, 21, 5, 5, 22, 21, 5, 23, 24, 25, 26, 26, 26, 27, 26, 26, 26, 26, 26, 26, 26, 28, 29, 10, 6, 6, 3, 3, 30, 30, 3, 3, 15, 14, 3, 31, 31, 32, 32, 32, 33, 34, 3, 33, 33, 32, 33, 32, 25, 21, 5, 5, 5, 5, 35, 35, 5, 5, 35, 5, 31, 5, 5, 5, 5, 5, 5, 35, 5, 36, 37, 38, 35, 35, 31, 35, 35, 35, 35, 35, 39, 40, 21, 27, 27, 41, 42, 27, 27, 1, 21, 21, 27, 39, 43, 17, 44, 45, 3, 3, 3, 46, 1, 47, 48, 47, 33, 33, 26, 14, 21, 21, 21, 21, 21, 21, 21, 35, 21, 21, 21, 21, 21, 21, 21, 35, 35, 49, 31, 31, 21, 21, 21, 21, 21, 21, 31, 21, 31, 31, 31, 31, 31, 31, 31, 31, 31, 35, 21, 50, 51, 51, 21, 43, 52, 27, 53, 53, 21, 26, 1, 30, 54, 54, 54, 55, 10, 10, 3, 30, 56, 57, 57, 57, 57, 1, 57, 25, 57, 3, 3, 3, 35, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 25, 25, 30, 30, 30, 58, 35, 35, 35, 35, 59, 16, 27, 27, 26, 27, 60, 27, 27, 27, 35, 21, 27, 26, 61, 61, 21, 52, 27, 54, 55, 62, 44, 3, 20, 30, 25, 25, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 49, 27, 20, 16, 21, 21, 21, 25, 50, 51, 53, 61, 54, 54, 53, 53, 63, 47, 1, 25, 25, 30, 25, 42, 27, 27, 26, 27, 27, 20, 37, 20, 25, 25, 43, 53, 47, 53, 26, 25, 
        };*/
}
