package pascal.table;

import pascal.iterator.*;
import pascal.OrdChar;

public class CaseLabelTable extends Table{
  private ConcreteAggregate list;

  public CaseLabelTable(){
    list = new ConcreteAggregate();  
  }

  public void enter(Entry entry) throws TableError {
    int order;
    String name = entry.getName();
    if(name.charAt(0) == '\''){
      order = OrdChar.getOrder(name);
    }else{
      order = Integer.parseInt(name);
    }
    ((CaseLabel)entry).setOrder(order);

    int i;
    for(i = 0; i < list.getLength(); i++){
      CaseLabel case_label = (CaseLabel)list.get(i);
      if(case_label.getOrder() == order){
        throw new TableError(name +" is already declared");
      }
      if(case_label.getOrder() > order){
        break;
      }
    }
    list.add(i , entry);
  }

  public Entry lookup(String name) throws TableError{
    Iterator it = list.iterator();
    while(it.hasNext()){
      CaseLabel label = (CaseLabel)it.next();
      if(label.getName().equals(name)){
        return label;
      }
    }
    throw  new TableError(name + " is not declared");
  }

  public Iterator iterator(){
    return list.iterator();
  }

  public int getMin(){
    return ((CaseLabel)list.get(0)).getOrder();
  }

  public int getMax(){
    return ((CaseLabel)list.get(list.getLength() - 1)).getOrder();
  }

}
