package pascal.table;

import java.util.Hashtable;

public class TableFactory{

  private SymbolTable table = null;
  private Hashtable pool = new Hashtable();

  private static TableFactory singleton = new TableFactory();

  private TableFactory(){}

  public static TableFactory getInstance(){
    return singleton;
  }

  public synchronized SymbolTable getSymbolTable(){
    if(table == null){
      table = new SymbolTable();
    }
    table.initialize();
    return table;
  }

  public synchronized CaseLabelTable getCaseLabelTable(int line, int pos){
    String key = new Integer(line).toString() + "-" + new Integer(pos).toString();
    CaseLabelTable case_label_table = (CaseLabelTable)pool.get(key);
    if(case_label_table == null){
      case_label_table = new CaseLabelTable();
      pool.put(key, case_label_table);
    }
    return case_label_table;
  }
}